set echo on
set feedback on
set serveroutput on
var start_date  varchar2(80);
var end_date    varchar2(80);
var sid         varchar2(10);
var host        varchar2(80);
var user        varchar2(30);


spool 3.1.0_Update_Script_Backout.log;

begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :start_date from dual;
  select instance_name into :sid from v$instance;
  select host_name into :host from v$instance;
  select user into :user from dual;

  dbms_output.put_line('Script executed on SID:  '||:sid);
  dbms_output.put_line('Script executed on host: '||:host);
  dbms_output.put_line('Script start date/time:  '||:start_date);
  dbms_output.put_line('Script executed by:      '||:user);
end;
/
SET DEFINE OFF;

REVOKE SELECT ON VAP.USER_DOCUMENT_SCHEDULE FROM VAP_READ;
REVOKE DELETE, INSERT, SELECT, UPDATE ON VAP.USER_DOCUMENT_SCHEDULE FROM VAP_USER;

REVOKE SELECT ON VAP.USER_DOCUMENT_SCHEDULE_AUDIT FROM VAP_READ;
REVOKE DELETE, INSERT, SELECT, UPDATE ON VAP.USER_DOCUMENT_SCHEDULE_AUDIT FROM VAP_USER;  

DROP SYNONYM VAP_APP.USER_DOCUMENT_SCHEDULE;
DROP SYNONYM VAP_APP.USER_DOCUMENT_SCHEDULE_AUDIT;

DROP TABLE VAP.USER_DOCUMENT_SCHEDULE_AUDIT;

DROP TABLE VAP.USER_DOCUMENT_SCHEDULE;

DROP FUNCTION VAP.GETFRIENDLYSCHEDULEFREQUENCY;

DELETE FROM VAP.DESCRIPTOR
WHERE NAME IN ('batchAnnounceDetailsFirstNameColumn','batchAnnounceDetailsLastNameColumn','batchAnnounceDetailsSSNColumn','batchAnnounceDetailsPatientIENColumn','batchAnnouncePatientsPatientCountColumn','batchAnnouncePatientsOrganzationNameColumn','optInPatientsReportEntryDateColumn','advancedSchedulingLogErrorColumn','advancedSchedulingLogRunEndDateColumn','advancedSchedulingLogRunStartDateColumn','advancedSchedulingLogFormatColumn','advancedSchedulingLogStatusColumn','advancedSchedulingFrequencyColumn','advancedSchedulingEndDateColumn','advancedSchedulingStartDateColumn','advancedSchedulingDateCreatedColumn','advancedSchedulingFormatColumn','advancedSchedulingTypeColumn','advancedSchedulingNameColumn','advancedSchedulingSelectAllColumn','advancedSchedulingEndBy','advancedSchedulingEndDateAfterOccurrences','advancedSchedulingFrequencyMonthlyDayOfMonth','advancedSchedulingFrequencyMonthlyMonths','advancedSchedulingFrequencyWeeklyDayOfWeek','advancedSchedulingFrequencyWeeklyWeeks','advancedSchedulingReportingPeriod','advancedSchedulingReportName');

-- backout update for extra-release update for CDW user to access VAP database
REVOKE SELECT ON VAP.ALLOWED_ROLE FROM CDW_READ;
REVOKE SELECT ON VAP.MAIL_NOTIFICATION FROM CDW_READ;
REVOKE SELECT ON VAP.USER_ROLE FROM CDW_READ;

DROP SYNONYM CDW_ETL.ALLOWED_ROLE;
DROP SYNONYM CDW_ETL.MAIL_NOTIFICATION;
DROP SYNONYM CDW_ETL.USER_ROLE;

COMMIT;

SET DEFINE ON;

Begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :end_date from dual;
  dbms_output.put_line('Script end date/time:    '||:end_date);
  dbms_output.put_line('Script executed in '||(to_date(:end_date, 'mm_dd_yyyy hh24:mi:ss') - to_date(:start_date, 'mm-dd-yyyy hh24:mi:ss')) *24*60*60||' seconds');
end;
/

Spool off;
