set echo on
set feedback on
set serveroutput on
var start_date  varchar2(80);
var end_date    varchar2(80);
var sid         varchar2(10);
var host        varchar2(80);
var user        varchar2(30);


spool 3.2.0_Update_Script.log;

begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :start_date from dual;
  select instance_name into :sid from v$instance;
  select host_name into :host from v$instance;
  select user into :user from dual;

  dbms_output.put_line('Script executed on SID:  '||:sid);
  dbms_output.put_line('Script executed on host: '||:host);
  dbms_output.put_line('Script start date/time:  '||:start_date);
  dbms_output.put_line('Script executed by:      '||:user);
end;
/
SET DEFINE OFF;

ALTER TABLE VAP.ALLOWED_ORG
ADD IS_BATCH_ANNOUNCE_ENABLED CHAR(1 BYTE) DEFAULT ('Y') NOT NULL;

UPDATE VAP.DESCRIPTOR
SET TEXT = 'This field allows for the user to select one or more eHealth organizations to send batch announcements. Announcements are made to share patient identifiers, such as ICNs, with partner systems to facilitate data sharing. Only those partner systems that have allowed batch announces (set in the Partner Organization edit screen) are shown here.'
WHERE NAME = 'batchAnnouncePatientsAllOrganizationsField';

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesRequestedHeader', 'This column displays the number of requrested batches.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIsBatchAnnounceEnabledField', 'This checkbox allows for selecting if a partner has batch announcing enabled.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIsBatchAnnounceEnabledColumn', 'This column denotes if a partner organization has batch announcing enabled.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryReportStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryReportEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoverySummaryReportStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoverySummaryReportEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'dqExportSearchStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'dqExportSearchEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

UPDATE VAP.DESCRIPTOR
SET TEXT = 'This form field requires the user to set an end for the recurrence of this advance scheduling task. Users must enter a numerical number between 1 and 30.'
WHERE NAME = 'advancedSchedulingEndDateAfterOccurrences'; 

COMMIT;
 
SET DEFINE ON;

Begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :end_date from dual;
  dbms_output.put_line('Script end date/time:    '||:end_date);
  dbms_output.put_line('Script executed in '||(to_date(:end_date, 'mm_dd_yyyy hh24:mi:ss') - to_date(:start_date, 'mm-dd-yyyy hh24:mi:ss')) *24*60*60||' seconds');
end;
/

Spool off;
