set echo on
set feedback on
set serveroutput on
var start_date  varchar2(80);
var end_date    varchar2(80);
var sid         varchar2(10);
var host        varchar2(80);
var user        varchar2(30);


spool 3.2.0_Update_Script_Backout.log;

begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :start_date from dual;
  select instance_name into :sid from v$instance;
  select host_name into :host from v$instance;
  select user into :user from dual;

  dbms_output.put_line('Script executed on SID:  '||:sid);
  dbms_output.put_line('Script executed on host: '||:host);
  dbms_output.put_line('Script start date/time:  '||:start_date);
  dbms_output.put_line('Script executed by:      '||:user);
end;
/
SET DEFINE OFF;

ALTER TABLE VAP.ALLOWED_ORG
DROP COLUMN IS_BATCH_ANNOUNCE_ENABLED;

DELETE FROM VAP.DESCRIPTOR
WHERE NAME IN ('manageBatchesRequestedHeader','partnerOrganizationIsBatchAnnounceEnabledField','partnerOrganizationIsBatchAnnounceEnabledColumn','patientDiscoveryReportStartDateField','patientDiscoveryReportEndDateField','patientDiscoverySummaryReportStartDateField','patientDiscoverySummaryReportEndDateField','dqExportSearchStartDateField','dqExportSearchEndDateField');

UPDATE VAP.DESCRIPTOR
SET TEXT = 'This field allows for the user to select one or more eHealth organizations to send batch announcements. Announcements are made to share patient identifiers, such as ICNs, with partner systems to facilitate data sharing.'
WHERE NAME = 'batchAnnouncePatientsAllOrganizationsField';

UPDATE VAP.DESCRIPTOR
SET TEXT = 'This field allows for the user to select one or more eHealth organizations to send batch announcements. Announcements are made to share patient identifiers, such as ICNs, with partner systems to facilitate data sharing.'
WHERE NAME = 'advancedSchedulingEndDateAfterOccurrences';

COMMIT;

SET DEFINE ON;

Begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :end_date from dual;
  dbms_output.put_line('Script end date/time:    '||:end_date);
  dbms_output.put_line('Script executed in '||(to_date(:end_date, 'mm_dd_yyyy hh24:mi:ss') - to_date(:start_date, 'mm-dd-yyyy hh24:mi:ss')) *24*60*60||' seconds');
end;
/

Spool off;
