CREATE TABLE VAP.ANNOUNCEMENT
(
  ANNOUNCEMENT_ID      NUMBER                   NOT NULL,
  BATCH_ID             VARCHAR2(255 BYTE),
  USER_ID              VARCHAR2(255 BYTE)       NOT NULL,
  CONSENT_DIR_ID       NUMBER,
  ORGANIZATION_ID      NUMBER,
  CREATED_TS           TIMESTAMP(6),
  SCHEDULED_TS         TIMESTAMP(6),
  COMPLETED_TS         TIMESTAMP(6),
  ANNOUNCEMENT_RESULT  CLOB,
  PATIENT_IEN          VARCHAR2(255 CHAR),
  HIE_TRANSACTION_ID   VARCHAR2(32 CHAR),
  FIRST_NAME           VARCHAR2(100 CHAR),
  LAST_NAME            VARCHAR2(100 CHAR),
  SSN                  VARCHAR2(20 CHAR)
);


CREATE INDEX VAP.ANNOUNCEMENT_IDX ON VAP.ANNOUNCEMENT
(CONSENT_DIR_ID, ORGANIZATION_ID);

CREATE UNIQUE INDEX VAP.ANNOUNCEMENT_PK ON VAP.ANNOUNCEMENT
(ANNOUNCEMENT_ID);

ALTER TABLE VAP.ANNOUNCEMENT ADD (
  CONSTRAINT ANNOUNCEMENT_PK
  PRIMARY KEY
  (ANNOUNCEMENT_ID)
  USING INDEX VAP.ANNOUNCEMENT_PK
  ENABLE VALIDATE);

CREATE INDEX VAP.ANNOUNCEMENT_BATCH_ORG_ID_IDX ON VAP.ANNOUNCEMENT
(BATCH_ID, ORGANIZATION_ID);

CREATE INDEX VAP.AC_ID_BATCH_ID_CREATED_TS_IDX ON VAP.ANNOUNCEMENT
(ANNOUNCEMENT_ID, BATCH_ID, TO_NUMBER(TO_CHAR(CREATED_TS, 'YYYYMMDDHH24MISS'), '99999999999999'));