CREATE TABLE VAP.CONSENT_AUDIT
(
  CONSENT_AUDIT_ID     NUMBER                   NOT NULL,
  ACTION_TYPE          VARCHAR2(255 BYTE),
  CONSENT_TYPE         VARCHAR2(255 BYTE),
  USER_ID              VARCHAR2(255 BYTE),
  FACILITY             VARCHAR2(255 BYTE),
  PATIENT_ID           VARCHAR2(255 BYTE),
  TIME_OF_EVENT        TIMESTAMP(6)             NOT NULL,
  DETAIL               CLOB,
  CREATED_DATE         TIMESTAMP(6)             NOT NULL,
  OPTOUT_REASON        VARCHAR2(4000 BYTE),
  PATIENT_SSN          VARCHAR2(255 BYTE),
  PATIENT_LAST_NAME    VARCHAR2(255 BYTE),
  PATIENT_GIVEN_NAME   VARCHAR2(255 BYTE),
  POU_VALUE            VARCHAR2(255 BYTE),
  FACILITY_NAME        VARCHAR2(255 BYTE),
  PATIENT_MIDDLE_NAME  VARCHAR2(255 CHAR)
);


CREATE INDEX VAP.CONSENT_AUDIT_IDX ON VAP.CONSENT_AUDIT
(ACTION_TYPE, USER_ID, FACILITY, PATIENT_ID, PATIENT_SSN, 
PATIENT_LAST_NAME, PATIENT_GIVEN_NAME, CREATED_DATE);

CREATE UNIQUE INDEX VAP.CONSENT_AUDIT_PK ON VAP.CONSENT_AUDIT
(CONSENT_AUDIT_ID);

CREATE INDEX VAP.IDX_CA_FACILITY ON VAP.CONSENT_AUDIT
(FACILITY);

CREATE INDEX VAP.IDX_CA_FACILITY_NAME ON VAP.CONSENT_AUDIT
(FACILITY_NAME);

ALTER TABLE VAP.CONSENT_AUDIT ADD (
  CONSTRAINT CONSENT_AUDIT_PK
  PRIMARY KEY
  (CONSENT_AUDIT_ID)
  USING INDEX VAP.CONSENT_AUDIT_PK
  ENABLE VALIDATE);

CREATE INDEX VAP.CONSENT_AUDIT_PAT_TYPE_IDX ON VAP.CONSENT_AUDIT
(PATIENT_ID, CONSENT_TYPE);

ALTER TABLE VAP.CONSENT_AUDIT
ADD IS_TEST_PATIENT NUMBER GENERATED ALWAYS AS (VAP.ISTESTPATIENT(PATIENT_SSN)) VIRTUAL VISIBLE;