CREATE TABLE VAP.DELAYED_CONSENT
(
  DELAYED_CONSENT_ID   NUMBER(19)               NOT NULL,
  PATIENT_IEN          VARCHAR2(255 CHAR)       NOT NULL,
  PATIENT_SSN          VARCHAR2(9 CHAR),
  PATIENT_LAST_NAME    VARCHAR2(50 CHAR)        NOT NULL,
  PATIENT_FIRST_NAME   VARCHAR2(50 CHAR)        NOT NULL,
  PATIENT_MIDDLE_NAME  VARCHAR2(50 CHAR),
  DATE_ADDED           TIMESTAMP(6)             NOT NULL,
  USER_ID              VARCHAR2(255 CHAR)       NOT NULL,
  STATION_NUMBER       VARCHAR2(10 CHAR),
  CONSENT_TYPE_ID      NUMBER(19)               NOT NULL,
  STATUS               VARCHAR2(8 CHAR)         DEFAULT 'PENDING'             NOT NULL,
  RESOLUTION_DATE      TIMESTAMP(6)
);


CREATE UNIQUE INDEX VAP.DELAYED_CONSENT_PK ON VAP.DELAYED_CONSENT
(DELAYED_CONSENT_ID);

ALTER TABLE VAP.DELAYED_CONSENT ADD (
  CONSTRAINT DELAYED_CONSENT_PK
  PRIMARY KEY
  (DELAYED_CONSENT_ID)
  USING INDEX VAP.DELAYED_CONSENT_PK
  ENABLE VALIDATE);
