CREATE TABLE VAP.PATIENT_CONFIDENTIALITY
(
  PATIENT_CONFIDENTIALITY_ID  INTEGER           NOT NULL,
  PATIENT_ICN                 VARCHAR2(255 BYTE) NOT NULL,
  CONFIDENTIALITY_CODE        VARCHAR2(255 BYTE) NOT NULL,
  STORED_TS                   DATE
);

CREATE UNIQUE INDEX VAP.PK_PATIENT_CONFIDENTIALITY ON VAP.PATIENT_CONFIDENTIALITY
(PATIENT_CONFIDENTIALITY_ID);

CREATE UNIQUE INDEX VAP.UK_PAT_CONF_PATIENT_ICN ON VAP.PATIENT_CONFIDENTIALITY
(PATIENT_ICN);

/*
CREATE SYNONYM VAP_APP.PATIENT_CONFIDENTIALITY FOR VAP.PATIENT_CONFIDENTIALITY;
*/

ALTER TABLE VAP.PATIENT_CONFIDENTIALITY ADD (
  CONSTRAINT PK_PATIENT_CONFIDENTIALITY
  PRIMARY KEY
  (PATIENT_CONFIDENTIALITY_ID)
  USING INDEX VAP.PK_PATIENT_CONFIDENTIALITY
  ENABLE VALIDATE);

ALTER TABLE VAP.PATIENT_CONFIDENTIALITY ADD (
  CONSTRAINT UK_PAT_CONF_PATIENT_ICN
  UNIQUE (PATIENT_ICN)
  USING INDEX VAP.UK_PAT_CONF_PATIENT_ICN
  ENABLE VALIDATE);

/*
GRANT SELECT ON VAP.PATIENT_CONFIDENTIALITY TO VAP_READ;

GRANT DELETE, INSERT, SELECT, UPDATE ON VAP.PATIENT_CONFIDENTIALITY TO VAP_USER;
*/

