CREATE TABLE VAP.PATIENT_CONSENT_DIR
(
  CONSENT_DIR_ID          NUMBER                NOT NULL,
  PATIENT_IEN             VARCHAR2(255 BYTE)    NOT NULL,
  OPTIN_DATE              TIMESTAMP(6)          NOT NULL,
  OPTOUT_TS               TIMESTAMP(6),
  EXPIRATION_DATE         TIMESTAMP(6),
  OPTIN_TS                TIMESTAMP(6)          NOT NULL,
  OPTOUT_REASON_ID        NUMBER,
  OPTIN_CONSENT_TYPE_ID   NUMBER                NOT NULL,
  POU_ID                  NUMBER,                
  OPTOUT_CONSENT_TYPE_ID  NUMBER,
  OPTOUT_DATE             TIMESTAMP(6)
);


CREATE INDEX VAP.PATIENT_CONSENT_DIR_IDX ON VAP.PATIENT_CONSENT_DIR
(PATIENT_IEN, OPTIN_TS);

CREATE UNIQUE INDEX VAP.PATIENT_CONSENT_DIR_PK ON VAP.PATIENT_CONSENT_DIR
(CONSENT_DIR_ID);

ALTER TABLE VAP.PATIENT_CONSENT_DIR ADD (
  CONSTRAINT PATIENT_CONSENT_DIR_PK
  PRIMARY KEY
  (CONSENT_DIR_ID)
  USING INDEX VAP.PATIENT_CONSENT_DIR_PK
  ENABLE VALIDATE);

ALTER TABLE VAP.PATIENT_CONSENT_DIR ADD (
  CONSTRAINT UC_PATIENT_CONSENT_DIR
  UNIQUE (PATIENT_IEN, OPTIN_CONSENT_TYPE_ID, OPTOUT_TS)
  ENABLE VALIDATE);

CREATE INDEX VAP.PATIENT_CONSENT_DIR_EXP_IDX ON VAP.PATIENT_CONSENT_DIR
(PATIENT_IEN, EXPIRATION_DATE);