/* updated with 3.3.0 release update */
CREATE OR REPLACE FORCE VIEW "VAP"."CONSENT_AUDIT_EX" ("CONSENT_AUDIT_ID", "ACTION_TYPE", "CONSENT_TYPE", "CREATED_DATE", "FACILITY", "FACILITY_NAME", "OPTOUT_REASON", "PATIENT_GIVEN_NAME", "PATIENT_ID", "PATIENT_LAST_NAME", "PATIENT_SSN", "POU_VALUE", "TIME_OF_EVENT", "USER_ID", "PATIENT_MIDDLE_NAME", "VISN_NAME", "VISN_NUMBER", "PARENT_STATION_NUMBER", "IS_TEST_PATIENT", "PARENT_FACILITY_NAME") AS 
SELECT c.CONSENT_AUDIT_ID, c.ACTION_TYPE, c.CONSENT_TYPE, c.CREATED_DATE,
     NVL(fa.FACILITY_STATION, c.FACILITY) AS FACILITY,
     NVL(fa.FACILITY_NAME, 'Unknown') AS FACILITY_NAME,
         c.OPTOUT_REASON, c.PATIENT_GIVEN_NAME, c.PATIENT_ID,
         c.PATIENT_LAST_NAME, c.PATIENT_SSN, c.POU_VALUE, c.TIME_OF_EVENT,
     LOWER(c.USER_ID), c.PATIENT_MIDDLE_NAME, v.VISN_NAME, v.VISN_NUMBER,
     CASE WHEN fa.FACILITY_PARENT IS NULL THEN fa.FACILITY_STATION ELSE fa.FACILITY_PARENT END AS PARENT_STATION_NUMBER,
     c.IS_TEST_PATIENT, 
     NVL(fb.FACILITY_NAME, 'Unknown') PARENT_FACILITY_NAME
FROM (
  SELECT ci.CONSENT_AUDIT_ID, ci.ACTION_TYPE, ci.CONSENT_TYPE, ci.CREATED_DATE,
         ci.FACILITY, ci.FACILITY_NAME, ci.OPTOUT_REASON, ci.PATIENT_GIVEN_NAME, ci.PATIENT_ID,
         ci.PATIENT_LAST_NAME, ci.PATIENT_SSN, ci.POU_VALUE, ci.TIME_OF_EVENT,
         ci.USER_ID, ci.PATIENT_MIDDLE_NAME, ci.IS_TEST_PATIENT, 
         (SELECT fi.FACILITY_ID FROM FACILITY fi WHERE ci.FACILITY = fi.FACILITY_STATION) STATION_LOOKUP_TYPE,
         (SELECT fi.FACILITY_ID FROM FACILITY fi WHERE substr(ci.FACILITY,1,3) = fi.FACILITY_STATION) FACILITY_LOOKUP_TYPE
  FROM CONSENT_AUDIT ci
) c
LEFT OUTER JOIN FACILITY fa ON fa.FACILITY_ID =
     CASE
       WHEN c.STATION_LOOKUP_TYPE IS NOT NULL THEN c.STATION_LOOKUP_TYPE
       WHEN c.FACILITY_LOOKUP_TYPE IS NOT NULL THEN c.FACILITY_LOOKUP_TYPE
     END
LEFT OUTER JOIN FACILITY fb ON CASE WHEN fa.FACILITY_PARENT IS NULL THEN fa.FACILITY_STATION ELSE fa.FACILITY_PARENT END = fb.FACILITY_STATION
LEFT OUTER JOIN VISN v ON fa.VISN_ID = v.ID;
