/**
 * US.01.02.07 - Send eHX Files to Diameter Health (DH) and DQ Team Server
 * 
 * Mock class version of eHX Adapter's Entity class of same name, which has 
 * String date properties instead of java.util.Date date properties, 
 * as it used to transform JSON strings to Java Objects to make the VAP 
 * log report display from the retrieved JSON string.  
 *
 */

package gov.va.nvap.service.dataquality;


import java.io.Serializable;


public class DqTransmissionLog implements Serializable {
    
    private static final long serialVersionUID = 1L;
  

    private Long dqTransmissionId;
    private String batchId;
    private String eventType;   
    private String startTime;
    private String endTime;
    private String hostname;
    private String localDocId;  
    private String filename; 
    private String filetype; 
    private Double filesize;
    private String destination;  
    private String status; 
    private String remoteDocId; 
    private String error;

    public Long getDqTransmissionId() {
        return this.dqTransmissionId;
    }

    public void setDqTransmissionId(Long dqTransmissionId) {
        this.dqTransmissionId = dqTransmissionId;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public String getStatus() {
        return this.status;
    }

    public void setStatus(String status) {
        this.status = status;
    }   

    public String getHostname() {
        return this.hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    public String getFilename() {
        return this.filename;
    }

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public Double getFilesize() {
        return this.filesize;
    }

    public void setFilesize(Double filesize) {
        this.filesize = filesize;
    }

    public String getDestination() {
        return this.destination;
    }

    public void setDestination(String destination) {
        this.destination = destination;
    }

    public String getError() {
        return this.error;
    }

    public void setError(String error) {
        this.error = error;
    }      

    public String getBatchId() {
        return batchId;
    }

    public void setBatchId(String batchId) {
        this.batchId = batchId;
    }

    public String getEventType() {
        return eventType;
    }

    public void setEventType(String eventType) {
        this.eventType = eventType;
    }

    public String getLocalDocId() {
        return localDocId;
    }

    public void setLocalDocId(String localDocId) {
        this.localDocId = localDocId;
    }

    public String getFiletype() {
        return filetype;
    }

    public void setFiletype(String filetype) {
        this.filetype = filetype;
    }

    public String getRemoteDocId() {
        return remoteDocId;
    }

    public void setRemoteDocId(String remoteDocId) {
        this.remoteDocId = remoteDocId;
    }    
    
    @Override
    public int hashCode()
    {
        int ret = 0;
        ret += (this.dqTransmissionId != null ? this.dqTransmissionId.hashCode() : 0);
        return ret;
    }
        
    @Override
    public boolean equals(Object obj)
    {
        if (!(obj instanceof DqTransmissionLog)) {
            return false;
        }
        DqTransmissionLog dqtl = (DqTransmissionLog)obj;
        if (this != dqtl && (this.dqTransmissionId == null || dqtl.dqTransmissionId == null || !this.dqTransmissionId.equals(dqtl.dqTransmissionId))) {
            return false;
        }
        return true;
    }
        
}
