package gov.va.nvap.common.file;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.springframework.core.io.Resource;

import org.apache.commons.io.FilenameUtils;

/**
 * @author Asha Amritraj
 */
public class FileUtil {

	public static String getResource(final Resource resource) throws IOException {
		final StringBuffer fileData = new StringBuffer(1000);
		final BufferedReader reader = new BufferedReader(new InputStreamReader(
				resource.getInputStream()));

		try {
			char[] buf = new char[1024];
			int numRead = 0;
			while ((numRead = reader.read(buf)) != -1) {
				final String readData = String.valueOf(buf, 0, numRead);
				fileData.append(readData);
				buf = new char[1024];
			}
		
		} finally {
			reader.close();
		}
		
		return fileData.toString();
	}
        
        /**
         * 
         * 
         * @author David Vazquez
         * 
         * @param path
         * @return
         * @throws FileNotFoundException 
         */
	static public InputStream getResourceAsStream(String path) throws FileNotFoundException
	{
            /* normalizes the file path to mitigate the Path manipulation/hacking vulnerability */
            path = FilenameUtils.normalize(path);
            InputStream ret = null;
            File f = new File(path);

            if(f.exists())
            {
                ret = new FileInputStream(f);
            }
            else
            {
                if(path.startsWith("file:"))
                {
                        path = path.substring(5);
                }
                ret = Thread.currentThread().getContextClassLoader().getResourceAsStream(path);
            }

            return ret;
	}          
        
	protected FileUtil() {
	}
}
