package gov.va.nvap.common.xsl;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.TransformerException;

import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

import org.springframework.context.annotation.Configuration;

/**
 * @author Asha Amritraj
 */
@Configuration
public class DefaultTransformerErrorListener implements ErrorListener {

        private static final Logger LOG = LoggerFactory.getLogger(DefaultTransformerErrorListener.class);

	@Override
	public final void error(final TransformerException ex)
			throws TransformerException {
		if (DefaultTransformerErrorListener.LOG.isErrorEnabled()) {
			DefaultTransformerErrorListener.LOG.error("",ex);
		}
		if (RuntimeException.class.isInstance(ex.getException())) {
			throw (RuntimeException) ex.getException();
		} else {
			throw ex;
		}
	}

	@Override
	public final void fatalError(final TransformerException ex)
			throws TransformerException {
		if (DefaultTransformerErrorListener.LOG.isErrorEnabled()) {
			DefaultTransformerErrorListener.LOG.error("",ex);
		}
		if (RuntimeException.class.isInstance(ex.getException())) {
			throw (RuntimeException) ex.getException();
		} else {
			throw ex;
		}
	}

	@Override
	public final void warning(final TransformerException ex)
			throws TransformerException {
		if (DefaultTransformerErrorListener.LOG.isWarnEnabled()) {
			DefaultTransformerErrorListener.LOG.warn("",ex);
		}
	}

}
