-- populate the DESCRIPTOR table

-- Consent Directive Summary Report
INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'startDateEndDateField', 'Enter the date in MM/DD/YYYY format. Do not enter date in "Start Date" or "End Date" field to search for all dates.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'authenticatingFacilityField', 'This field filters the report by authenticating facility. Field defaults to the location associated to a User''s VA User ID.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeField', 'This field filters the data within the resultant report by consent types (all, authorizations, revocations and or restrictions).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'patientTypesField', 'This field filters the data to include or not include test patient data within the resultant report. By default, only Real Patients are selected.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'authenticatingFacilityColumn', 'This column lists the authenticating facility. Report defaults to facilities in alphabetical order.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeColumn', 'This column provides the consent types (all, authorizations, revocations and or restrictions).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryReportTotalColumn', 'This column lists the total consents for the associated consent type within a facility. Totals can be updated to exclude or include test patients or specified timeframe.');

-- Consent Directive Detailed Report
INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'ssnField', 'Enter nine (9) numbers only with no hyphens to filter report by a specific Social Security Number. System defaults to blank field to search for all SSNs.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'lastNameField', 'This field filters the resultant report by Last Name and is not case-sensitive.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'firstNameField', 'This field filters the resultant report by First Name and is not case-sensitive.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'vaVISNField', 'This field allows for customization of reports by VISN and Facilities. Select the button enter your facility choices.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'enteredByField', 'This field filters the resultant report to display consents entered  by individual (manual entry) or entered by system (i.e., eBenefits).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportPatientTypes', 'By default, only Real Patients are searched for. Click dropdown to display All Patients or only Test Patients results.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'ssnColumn', 'This column displays the Social Security Number (SSN) for individuals within this report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'lastNameColumn', 'This column displays the Last Name of the individual listed within this report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'firstNameColumn', 'This column displays the First Name of the individual listed within this report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eventOccurredColumn', 'This column displays the timestamp (date and time) for when the event occurred. This is shown in Central Time.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeSansAllColumn', 'This column displays the consent types (authorization, revocations and or restrictions) and whether these are eHX or SSA consents.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'enteredByManualOrSystemColumn', 'This column displays whether the consent was entered  by individual (manual entry) or entered by system (i.e., eBenefits).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportAuthenticatingFacilityColumn', 'This column displays the facility that authenticated the consent directive (as it may not be the Veterans preferred facility).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'visnForAuthenticatingFacilityColumn', 'This column displays the VISN associated to the authenticating facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'optInDateColumn', 'This column displays the date Individual opted to authorize consent to share health information.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'expirationDateColumn', 'This column shows the date the individual''s consent to share information expires.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'expiringConsentDetailedReportConsentTypeColumn', 'This column displays the consent types (authorization, revocations and or restrictions) and whether these are eHX or SSA consents.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeOrganizationField', 'This field reflects the organizations to which patient discovery messages were sent.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeOrganizationColumn', 'This column displays organizations to which patient discovery messages were sent.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'vaFacilityColumn', 'This column displays the VA facilities that sent the patient discovery messages.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'uniqueRealPatientsCountColumn', 'This column displays the total number of unique real patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'matchesFoundForRealPatientsCountColumn', 'This column displays the number of matches found for real patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'failsForRealPatientsCountColumn', 'This column displays the number of fails for real patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'uniqueTestPatientsCountColumn', 'This column displays the total number of unique test patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'matchesFoundForTestPatientsCountColumn', 'This column displays the total matches found for test patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'failsForTestPatientsCountColumn', 'This column displays the total match fails for test patients.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryAuditReportSSNField', 'This field filters the resultant report by SSN. One or multiple SSNs, separated by comma, with no hyphens may be entered. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'mpiResultsField', 'This field allows you to filter the resultant report by all, match found, or match failed.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'recordsPerPageField', 'This field reflects the organizations to which patient discovery (announcement) messages were sent.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'includeTestPatientsField', 'Select checkbox to include test patients in the resultant report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'sendingOrganizationColumn', 'This column displays the sending organization for the patient discovery message (announcement).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'purposeOfUseColumn', 'This column displays the purpose of use (treatment, emergency, coverage).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivingOrganizationColumn', 'This column displays the receiving organization for the patient discovery message (announcement).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'explanationOfFailureColumn', 'This column provides an explanation of failure, for the announcement that failed.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'detailsColumn', 'This column displays any additional details received.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeAuthorizationColumn', 'This column displays the count of eHealth  Exchange Authorizations that have been processed by a facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeSSAAuthorizationColumn', 'This column displays the count of eHealth  Exchange Authorizations that have been processed by a facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeAuthorizationProcessedTotal', 'This column displays the total count of eHealth Exchange Authorizations and SSA Authorizations that have been processed by a facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'middleNameColumn', 'This column displays the middle name of the individual listed within this report.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportOptInDateColumn', 'This column displays the date the individual was opted in (date authorization submitted).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportExpirationDateColumn', 'This column displays the expiration date for the authorization (i.e., authorization date plus five (5) years for eHealth Exchange or two (2) years for SSA).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportAuthenticatingFacilityColumn', 'This column displays the facility which authenticated or entered the consent.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'reasonsForDelayField', 'These checkboxes allow the user to filter the resultant report by delay type.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'daysSinceDelayedField', 'This field filters the data within the resultant report to limit the search to delays within a specified time period (10 days, 30 days, 60 days).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportConsentTypeField', 'This field filters the data within the resultant report by consent types (all, authorizations, revocations and or restrictions).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportAuthenticatingFacilityColumn', 'This column displays the facility that authenticated the consent directive (as it may not be the Veterans preferred facility).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportTotalColumn', 'This column lists the total consents for the associated consent type within a facility. Totals can be updated to exclude or include test patients or specified timeframe.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'multipleSSNsField', 'One or multiple SSNs, separated by comma, with no hyphens. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'enteredDateColumn', 'This column displays the timestamp (Date and Time) for when the event occurred. This is shown in Central Time.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'icnColumn', 'This column displays the unique patient identifier associated to the individual.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'reasonsForDelayColumn', 'This column displays the reason(s) for delay (form not signed, form content altered, demographic changes, privacy officer review, signature verification, and power of attorney not on file).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportAuthenticatingFacilityColumn', 'This column displays the facility that authenticated the consent directive (as it may not be the Veterans preferred facility).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportOrganizationField', 'This field allows for filtering for organizations which VA received documents through eHealth Exchange.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportFacilityColumn', 'This field filters the report by the VA facility. Field defaults to the location associated to a Users VA User ID.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportOrganizationField', 'This field allows for filtering for organizations which VA received documents through eHealth Exchange.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportIncludeTestPatientsField', 'Use checkmark to include Test Patients in the results.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSourceField', 'Click to select the disclosure source either from Exchange (default) or Direct.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresSummaryReportOrganizationField', 'This field allows for filtering of the organizations to which the VA disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportVAFacilityField', 'This field filters the report by the individual''s VA facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportOrganizationField', 'This field allows for filtering of the organizations to which the VA disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportIncludeTestPatientsField', 'Use checkmark to include Test Patients in the results.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureDateField', 'This column displays the timestamp (date and time) for when the event occurred. This is shown in Central Time.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'vaFacilityFilterColumn', 'This field filters the report by the individual''s VA facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportOrganization', 'This column displays the organizations to which the VA disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'auditsColumn', 'This column displays the number of audit transactions per partner by a VA facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'messageColumn', 'This column displays type of logged patient discovery transaction (Add Patient Correlation, Check Policy, etc.)');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureColumn', 'This column displays the type of disclosure made.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresUserIdColumn', 'This column displays the User ID for the disclosures transaction.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'patientSearchSSNField', 'Enter nine (9) numbers only with no hyphens to filter report by a specific Social Security Number.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportConsentTypeColumn', 'This column displays the consent types (authorization, revocations and or restrictions) and whether these are eHX or SSA consents.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportSSNField', 'This field filters the resultant report by SSN. One or multiple SSNs, separated by comma, with no hyphens may be entered. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportConsentTypeColumn', 'This column displays the consent types (authorization, revocations and or restrictions) and whether these are eHX or SSA consents.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportFacilityField', 'This field filters the report by the VA facility. Field defaults to the location associated to a User''s VA User ID.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'purposeOfUseField', 'This field allows for filtering by purpose of use (treatment, emergency, coverage).');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresSummaryReportFacilityField', 'This field filters the report by the VA facility. Field defaults to the location associated to a User''s VA User ID.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'documentTitleColumn', 'This column displays the document title retrieved by the user.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportFacilityWithDefaultField', 'This column displays the VA facilities defaulted to the location associated to a Users VA User ID.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportOrganizationColumn', 'This column displays the organizations which VA received documents through eHealth Exchange.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportUserIdColumn', 'This column displays the User ID of the user who retrieved the data.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportUserRoleColumn', 'This column displays the User Role of the user who retrieved the data.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportOrganizationColumn', 'This column displays the organization to which the VA disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportFacilityColumn', 'This column displays the VA facilities that sent the patients disclosed records.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportTotalColumn', 'This column lists the total disclosures for the associated disclosures type within a facility. Totals can be updated to exclude or include test patients or specified timeframe.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportOrganizationColumn', 'This column displays the organizations from which VA received documents through eHealth Exchange.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportVAFacilityColumn', 'This column displays the VA Facility which received the documents through eHealth Exchange from the eHealth Exchange Organization displayed to the left.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportTotalColumn', 'This column displays the total count of documents from that organization received by the VA Facility.');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'userIdField', 'Use this field to filter by partial or full ID of the user that entered or submitted the consent (e.g. "eBenefits", "vhaxxx").');

INSERT INTO DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureReportFacilityNumberColumn', 'This column displays the facility number for the patient''s preferred facility.');

COMMIT;