set echo on
set feedback on
set serveroutput on
var start_date  varchar2(80);
var end_date    varchar2(80);
var sid         varchar2(10);
var host        varchar2(30);
var user        varchar2(30);


spool 2.7.2_Update_Script_Backout.log;

begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :start_date from dual;
  select instance_name into :sid from v$instance;
  select host_name into :host from v$instance;
  select user into :user from dual;

  dbms_output.put_line('Script executed on SID:  '||:sid);
  dbms_output.put_line('Script executed on host: '||:host);
  dbms_output.put_line('Script start date/time:  '||:start_date);
  dbms_output.put_line('Script executed by:      '||:user);
end;
/
SET DEFINE OFF;

DROP SYNONYM VAP_APP.PATIENT_CONFIDENTIALITY;

DROP TABLE VAP.PATIENT_CONFIDENTIALITY;

DELETE FROM VAP.CONSENT_TYPE WHERE NAME = 'Withhold for Treatment Authorization';

DELETE FROM VAP.CONSENT_TYPE WHERE NAME = 'Withhold for Treatment Revocation';

--------------------------------------------------------
--  UPDATE DESCRIPTORS
--  These statements came from VAP-E team as part of Section 508 fixes
--  they made post- VAP 2.7.1. Manually "merged" them into this
--  SQL file for the VAP 2.7.2 release (eHX-E Build 3).
--------------------------------------------------------
UPDATE VAP.DESCRIPTOR SET TEXT='Move all organizations to the right box.' WHERE NAME='batchAnnounceMoveAll';
UPDATE VAP.DESCRIPTOR SET TEXT='Move the selected organizations to the right box.' WHERE NAME='batchAnnounceMoveSelectedRight';
UPDATE VAP.DESCRIPTOR SET TEXT='Move the selected organizations to the left box.' WHERE NAME='batchAnnounceMoveSelectedLeft';

Set Define on;

Begin
  select to_char(sysdate, 'mm-dd-yyyy hh24:mi:ss') into :end_date from dual;
  dbms_output.put_line('Script end date/time:    '||:end_date);
  dbms_output.put_line('Script executed in '||(to_date(:end_date, 'mm_dd_yyyy hh24:mi:ss') - to_date(:start_date, 'mm-dd-yyyy hh24:mi:ss')) *24*60*60||' seconds');
end;
/

Spool off;
