/**
 * 
 * 
 * 
 */
package gov.va.nvap.mock.endpoint.dataquality;


import gov.va.nvap.service.audit.AuditException;
import gov.va.nvap.service.dataquality.DqTransmissionLogManager;
import gov.va.nvap.service.dataquality.DqTransmissionLogQueryRequest;

import java.net.MalformedURLException;
import java.io.InputStream;
import java.io.IOException;
import java.nio.charset.StandardCharsets;

import org.apache.commons.io.IOUtils;

import org.slf4j.LoggerFactory;
import org.slf4j.Logger;




/**
 *
 * 
 */
// TODO: Uncomment these two lines to use mock, and comment-out these lines in the real class
//@Stateless(name = "DqTransmissionLogManager", mappedName = "DqTransmissionLogManager")
//@javax.ejb.Remote(DqTransmissionLogManager.class)
public class MockDqTransmissionLogServiceEndpoint implements DqTransmissionLogManager {
    
    private static final Logger LOG = LoggerFactory.getLogger(MockDqTransmissionLogServiceEndpoint.class);

    public MockDqTransmissionLogServiceEndpoint() {
        super();
    }
    
    
    @Override
    public String getDqTransmissionLogData(DqTransmissionLogQueryRequest logQueryRequest) throws AuditException {
        
        //final String mockFilename = "sampleDQTransmissionLogServiceResponseJsonString.json"; 
        final String mockFilename = this.responseDataFile;
        //InputStream inputStream = getClass().getClassLoader().getResourceAsStream(mockFilename);
        try (
            InputStream inputStream = getClass().getClassLoader().getResourceAsStream(mockFilename);    
        ) {
            // TODO: file is in nvap-server/src/test/resources/gov/.../dataquality, 
            // needs to be placed in src/test/resources, and needs to be allowed in by Maven filtering include for .json
            
            String response = IOUtils.toString(inputStream, StandardCharsets.UTF_8.name());
            
            LOG.debug(" mock dq response data is: "+response);
            return response;
     
        } catch (MalformedURLException e) {
            //e.printStackTrace(System.out);
            LOG.error("",e);  
            throw new AuditException("DqTransmissionLogServiceEndpoint GET request threw Exception: ",e);
        } catch (IOException e) {
            //e.printStackTrace(System.out);
            LOG.error("",e);  
            throw new AuditException("DqTransmissionLogServiceEndpoint GET request threw Exception: ",e);          
        }
        finally
        {
            //IOUtils.closeQuietly(inputStream);
        }
    }
    private String responseDataFile;

    /**
     * Set the value of responseDataFile
     *
     * @param responseDataFile new value of responseDataFile
     */
    public void setResponseDataFile(String responseDataFile) {
        this.responseDataFile = responseDataFile;
    }

    
}
