package gov.va.nvap.server.service.privacy.emailer;

import gov.va.nvap.common.file.FileUtil;
//import gov.va.nvap.propertylookup.PropertyLookup;
//import gov.va.nvap.propertylookup.PropertyLookupLocal;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
//import javax.ejb.EJB;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;


public class EmailBean {
    
        private static final Logger LOG = LoggerFactory.getLogger(EmailBean.class);
        private static final String SERVER_PROPERTIES_LOCATION = "config/vap/server.properties"; 
    
        //private PropertyLookup propertyLookup;     
	public String subject;
	public String body;
	public String from;
	public String host;
	public String username;
	public String password;
	public String port;
	public String link;
	private static EmailBean emailBean;	
	
	private EmailBean() {
            InputStream in = null;
            Properties p;

            try {
                LOG.debug("retrieving server.properties at location: "+SERVER_PROPERTIES_LOCATION);
                p = new Properties();
                in = FileUtil.getResourceAsStream(SERVER_PROPERTIES_LOCATION);
                if(null == in) {
                    throw new IOException("InputStream returned null from FileUtil.getResourceAsStream()!");
                }            
                p.load(in);
                
                setSubject(p.getProperty("email.subject"));
                setBody(p.getProperty("email.body"));
                setFrom(p.getProperty("email.from"));
                setHost(p.getProperty("email.host"));
                setUsername(p.getProperty("email.username"));
                setPassword(p.getProperty("email.password"));
                setPort(p.getProperty("email.port"));
                setLink(p.getProperty("email.link"));                
            }
            catch (IOException ioe) {
                LOG.warn("Error loading server.properties.  Returning null.", ioe);
                //p = null;
            }
            finally {
                try {
                    if (in != null) {
                        in.close();
                    }
                }
                catch (IOException ioe) {
                    LOG.warn("Error closing input stream.", ioe);
                }
            }  
            

	}
	
	public static synchronized EmailBean getInstance(){		
		if ( emailBean == null ){
			emailBean = new EmailBean();
		}
		return emailBean;
	}
	
	
	public final String getSubject() {
		return subject;
	}

	public final void setSubject(String subject) {
		this.subject = subject;
	}

	public final String getBody() {
		return body;
	}

	public final void setBody(String body) {
		this.body = body;
	}

	public final String getFrom() {
		return from;
	}
	
	public final void setFrom(String from) {
		this.from = from;
	}
	
	public final String getHost() {
		return host;
	}
	public final void setHost(String host) {
		this.host = host;
	}
	public final String getUsername() {
		return username;
	}
	public final void setUsername(String username) {
		this.username = username;
	}
	public final String getPassword() {
		return password;
	}
	public final void setPassword(String password) {
		this.password = password;
	}
	public final String getPort() {
		return port;
	}
	public final void setPort(String port) {
		this.port = port;
	}
	public final String getLink() {
		return link;
	}
	public final void setLink(String link) {
		this.link = link;
	}
        
//        @EJB(beanInterface = PropertyLookupLocal.class, beanName = "ServerPropertyFileLookup")
//        public void setPropertyLookup(PropertyLookup propertyLookup)
//        {
//            this.propertyLookup = propertyLookup;
//        }         
	
}
