package gov.va.nvap.server.test.endpoint.privacy;

import gov.va.nvap.common.file.FileUtil;
import gov.va.nvap.common.transformer.TransformerException;
import gov.va.nvap.common.transformer.xml.StringToXML;
import gov.va.nvap.common.transformer.xml.XMLToString;
import gov.va.nvap.common.transformer.xsl.XMLtoXML;
import gov.va.nvap.common.validation.Assert;
import gov.va.nvap.common.xpath.XPathException;
import gov.va.nvap.server.test.common.AbstractTestCase;

import java.io.IOException;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import org.hl7.v3.POCDMT000040ClinicalDocument;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.w3c.dom.Document;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath:gov/va/nvap/server/endpoint/pdq/pdq-endpoint.xml","classpath:gov/va/nvap/server/service/privacy/privacy-service.xml"}) 
public class TestPatientConsentDirectiveDataToDocumentTest extends AbstractTestCase {

        //TODO: FIgure out how to inject this into CMSImpl/bean in order to run this test
        //@PersistenceContext
        //EntityManager em;
    
	@Resource(name = "patientConsentDirectiveDataToDocument")
	private XMLtoXML patientConsentDirectiveDataToDocument;

	@Test
	public void testTransformer() throws IOException, TransformerException,
			XPathException, JAXBException {               
            
		final org.springframework.core.io.Resource resource = this.applicationContext
				.getResource("classpath:gov/va/nvap/server/test/service/privacy/ConsentDirectiveData.xml");
                
		final String consentDirectiveData = FileUtil.getResource(resource);
		final Document consentDirectiveDataDoc = new StringToXML()
				.transform(consentDirectiveData);

		final Document doc = this.patientConsentDirectiveDataToDocument
				.transform(consentDirectiveDataDoc);
		System.out.println(new XMLToString(true).transform(doc));
		final JAXBContext context = JAXBContext.newInstance("org.hl7.v3");
		final Unmarshaller unmarshaller = context.createUnmarshaller();
		final Object obj = unmarshaller.unmarshal(doc);
		final POCDMT000040ClinicalDocument document = (POCDMT000040ClinicalDocument) ((JAXBElement<?>) obj)
				.getValue();
		Assert.assertNotEmpty(document, "Document cannot be null!");
	}

}
