/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.svc.consentmgmt.stub.adapter.announce.data;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.ColumnResult;
import javax.persistence.ConstructorResult;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.SqlResultSetMapping;

/**
 * 
 * @author PII
 */

/**
* this mapping is used when this object (its not a persisted entity) is used as a return type for a query or a return type of a list of these. 
* it uses one of the constructors. the names below are the COLUMN names returned by the query and they should be typed, otherwise hibernate does 
* not know what constructor to use when creating/populating this object from the return of a query 
*/

@SqlResultSetMapping(
    name="AnnouncementBatchSummaryResult",
    classes={
        @ConstructorResult (
            targetClass=AnnouncementBatchSummary.class,
            columns={
                @ColumnResult(name="BATCH_ID", type=String.class),
                @ColumnResult(name="ORG_NAME", type=String.class),
                @ColumnResult(name="ORG_ID", type=Long.class),
                @ColumnResult(name="BATCH_SIZE", type=Long.class),
                @ColumnResult(name="CREATED_TS", type=Date.class),
                @ColumnResult(name="NUM_SCHEDULED", type=Long.class),
                @ColumnResult(name="NUM_COMPLETED", type=Long.class),
                @ColumnResult(name="NUM_FAILED", type=Long.class)
            }
        )
    }
)

@Entity
public class AnnouncementBatchSummary implements Serializable {
    private static final long serialVersionUID = 1L;
    
    @Id
    private String batchId;

    private Long batchSize;

    private Date createdDate;

    private Long numberCompleted;

    private Long numberScheduled;
    
    private Long numberFailed;

    private String targetOrganizationName;
    
    private Long orgId;
    
    private Long numberSuccessful;

    public AnnouncementBatchSummary(final String targetOrganizationName, final Long batchSize, final Date createdDate) {
        this.setTargetOrganizationName(targetOrganizationName);
        this.setBatchSize(batchSize);
        this.setCreatedDate(createdDate);
    }

    public AnnouncementBatchSummary(final String batchId, final String testOrganizationName, final Long batchSize, final Date createdDate, final Long numberScheduled, final Long numberCompleted) {
        this(testOrganizationName, batchSize, createdDate);
        this.setBatchId(batchId);
        this.setNumberScheduled(numberScheduled);
        this.setNumberCompleted(numberCompleted);
    }
    
    public AnnouncementBatchSummary(final String batchId, final String testOrganizationName, final Long orgId, final Long batchSize, final Date createdDate, final Long numberScheduled, final Long numberCompleted) {
        this(testOrganizationName, batchSize, createdDate);
        this.setBatchId(batchId);
        this.setNumberScheduled(numberScheduled);
        this.setNumberCompleted(numberCompleted);
        this.setOrgId(orgId);
    }

//    public AnnouncementBatchSummary(final String batchId, final String testOrganizationName, final Long orgId, final Long batchSize, final Date createdDate, final Long numberScheduled, final Long numberCompleted, final Long numberSuccessful) {
//        this(testOrganizationName, batchSize, createdDate);
//        this.setBatchId(batchId);
//        this.setNumberScheduled(numberScheduled);
//        this.setNumberCompleted(numberCompleted);
//        this.setOrgId(orgId);
//        this.setNumberSuccessful(numberSuccessful);
//    }
    
    public AnnouncementBatchSummary(final String batchId, final String testOrganizationName, final Long orgId, final Long batchSize, final Date createdDate, final Long numberScheduled, final Long numberCompleted, final Long numberFailed) {
        this(testOrganizationName, batchSize, createdDate);
        this.setBatchId(batchId);
        this.setNumberScheduled(numberScheduled);
        this.setNumberCompleted(numberCompleted);
        this.setNumberFailed(numberFailed);
        this.setOrgId(orgId);
    }    
    
    public String getBatchId() {
            return this.batchId;
    }

    public Long getBatchSize() {
            return this.batchSize;
    }

    public Date getCreatedDate() {
            return this.createdDate;
    }

    public Long getNumberCompleted() {
            return this.numberCompleted;
    }

    public Long getNumberScheduled() {
            return this.numberScheduled;
    }
    
    public Long getNumberFailed() {
        return this.numberFailed;
    }

    public String getTargetOrganizationName() {
            return this.targetOrganizationName;
    }

    private void setBatchId(final String batchId) {
            this.batchId = batchId;
    }

    private void setBatchSize(final Long batchSize) {
            this.batchSize = batchSize;
    }

    private void setCreatedDate(final Date createdDate) {
            this.createdDate = createdDate;
    }

    private void setNumberCompleted(final Long numberCompleted) {
            this.numberCompleted = numberCompleted;
    }

    private void setNumberScheduled(final Long numberScheduled) {
            this.numberScheduled = numberScheduled;
    }
    
    private void setNumberFailed(final Long numberFailed) {
            this.numberFailed = numberFailed;
    }

    private void setTargetOrganizationName(final String targetOrganizationName) {
            this.targetOrganizationName = targetOrganizationName;
    }

    public Long getOrgId() {
        return orgId;
    }

    private void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public Long getNumberSuccessful() {
        return numberSuccessful;
    }

    public void setNumberSuccessful(Long numberSuccessful) {
        this.numberSuccessful = numberSuccessful;
    }
    
    
}
