/**
 *
 */
package gov.va.nvap.svc.consentmgmt.stub.adapter.announce.data;

import gov.va.med.nhin.adapter.announce.BatchAnnounceType;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;

import org.springframework.beans.factory.annotation.Required;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.jms.core.MessageCreator;

/**
 * @author PII
 *
 */
public class PatientConsentBatchAnnounce {
	JmsTemplate jmsTemplate;

	public void batchAnnounce(final String[] batchIds, final String user,
			final String facility) {
		final BatchAnnounceType announcement = new BatchAnnounceType();
		announcement.setBatchIds(batchIds);
		announcement.setUser(user);
		announcement.setFacility(facility);
		announcement.setMaxBatchSize(1000);
		this.jmsTemplate.send(new MessageCreator() {
			@Override
			public Message createMessage(final Session session)
					throws JMSException {
				final Message msg = session.createObjectMessage(announcement);
				return msg;
			}
		});
	}

	@Required
	public void setJmsTemplate(final JmsTemplate jmsTemplate) {
		this.jmsTemplate = jmsTemplate;
	}
}
