/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.svc.consentmgmt.stub.dao;

import gov.va.nvap.svc.consentmgmt.stub.data.Permission;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Betty Wong
 */
public class PermissionDAO {
    @PersistenceContext
    private EntityManager em;
    
    @Transactional
    public List<Permission> getAll() {
        try {
            final TypedQuery<Permission> q = this.em.createQuery("SELECT p FROM Permission p", Permission.class);
            
            return q.getResultList();
        } catch (final Exception e) {
            return new ArrayList<Permission>();
        }
    }
    
    @Transactional
    public List<Permission> getPermissionsByServletAndMethod(String servletShortName, String methodName) {
        try {
            final TypedQuery<Permission> q = this.em.createQuery("SELECT p FROM Permission p WHERE p.servletShortName IN (:servletShortName) AND IN (:methodName)", Permission.class);
            q.setParameter("servletShortName", servletShortName);
            q.setParameter("methodName", methodName);
            
            return q.getResultList();
        } catch (final Exception e) {
            return new ArrayList<Permission>();
        }
    }
    
    @Transactional
    public List<Permission> getPermissionsByServletShortName(String servletShortName) {
        try {
            final TypedQuery<Permission> q = this.em.createQuery("SELECT p FROM Permission p WHERE p.servletShortName IN (:servletShortName)", Permission.class);
            q.setParameter("servletShortName", servletShortName);
            
            return q.getResultList();
        } catch (final Exception e) {
            return new ArrayList<Permission>();
        }
    }
    
    @Transactional
    public List<Permission> getPermissionsByMethodName(String methodName) {
        try {
            final TypedQuery<Permission> q = this.em.createQuery("SELECT p FROM Permission p WHERE p.methodName IN (:methodName)", Permission.class);
            q.setParameter("methodName", methodName);
            
            return q.getResultList();
        } catch (final Exception e) {
            return new ArrayList<Permission>();
        }
    }
    
    
}
