package gov.va.nvap.web.user;

import java.io.Serializable;

/**
 * @author Johann P. Sonnenberg
 * used to store user preferences in session. i.e. the sort order they want/have used on a report
 * 
 * current list of user preferences set throughout the application:
 * reportFacilitySortColumn - numeric value of the column to sort by
 * reportFacilitySortDirection - asc/desc of the sort direction
 */

public class UserPreference implements Serializable {
    
    private static final long serialVersionUID = 1L;
    
    private String key;
    private String value;
    
    public UserPreference() {}
    
    public UserPreference(String key, String value) {
        setKey(key);
        setValue(value);
    }

    public final String getKey() {
        return key;
    }

    public final void setKey(String key) {
        this.key = key;
    }

    public final String getValue() {
        return value;
    }

    public final void setValue(String value) {
        this.value = value;
    }
}
