package gov.va.nvap.web.user.document;

import java.util.Date;

/**
 *
 * @author Johann P. Sonnenberg
 * 
 * Represents a summary of a managed scheduled export (UserDocumentSchedule) and partial audit (UserDocumentScheduleAudit) information
 */
public class UserDocumentScheduleSummary {
    
    
    private Long scheduleId;
    private String userId; 
    private String reportType;
    private String userDefinedReportName;
    private String frequency;
    private String format; 
    private Date runStartDate;
    private Date runEndDate;
    private String status;
    private String errorMessage; 
    private Date creationDate;
    private Date lastUpdatedDate;
    private String frequencyText;

    public UserDocumentScheduleSummary() {
    }

    public UserDocumentScheduleSummary(Long scheduleId, String reportType, String userDefinedReportName, String frequency, String format, Date creationDate, Date lastUpdatedDate, Date runStartDate, Date runEndDate, String status, String errorMessage, String frequencyText ) {
        this.scheduleId = scheduleId;
        this.reportType = reportType;
        this.userDefinedReportName = userDefinedReportName;
        this.frequency = frequency;
        this.format = format;
        this.creationDate = creationDate;
        this.lastUpdatedDate = lastUpdatedDate;
        this.runStartDate = runStartDate;
        this.runEndDate = runEndDate;
        this.status = status;
        this.errorMessage = errorMessage;
        this.frequencyText = frequencyText;
    }

    public Long getScheduleId() {
        return scheduleId;
    }

    public void setScheduleId(Long scheduleId) {
        this.scheduleId = scheduleId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getReportType() {
        return reportType;
    }

    public void setReportType(String reportType) {
        this.reportType = reportType;
    }

    public String getUserDefinedReportName() {
        return userDefinedReportName;
    }

    public void setUserDefinedReportName(String userDefinedReportName) {
        this.userDefinedReportName = userDefinedReportName;
    }

    public String getFrequency() {
        return frequency;
    }

    public void setFrequency(String frequency) {
        this.frequency = frequency;
    }

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    public Date getRunStartDate() {
        return runStartDate;
    }

    public void setRunStartDate(Date runStartDate) {
        this.runStartDate = runStartDate;
    }

    public Date getRunEndDate() {
        return runEndDate;
    }

    public void setRunEndDate(Date runEndDate) {
        this.runEndDate = runEndDate;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Date getLastUpdatedDate() {
        return lastUpdatedDate;
    }

    public void setLastUpdatedDate(Date lastUpdatedDate) {
        this.lastUpdatedDate = lastUpdatedDate;
    }

    public String getFrequencyText() {
        return frequencyText;
    }

    public void setFrequencyText(String frequencyText) {
        this.frequencyText = frequencyText;
    }
}
