package gov.va.nvap.web.util;

import gov.va.nvap.common.file.FileUtil;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;


/**
 * Class to hold static-level properties for nvap-web. 
 * Using EJBs at static level is apparently a bad idea.
 * 
 */
public class Constants {
    
    private static final String WEB_PROPERTIES_LOCATION = "config/vap/web.properties";    
    
    private static final Logger LOG = LoggerFactory.getLogger(Constants.class);
    
    private static Properties props;
    
    private static String organizationName;    
     
    static {
        //InputStream in = null;
        try (InputStream in = FileUtil.getResourceAsStream(WEB_PROPERTIES_LOCATION);){
            props = new Properties();
//            in = FileUtil.getResourceAsStream(WEB_PROPERTIES_LOCATION);
//            if(null == in) {
//                throw new IOException("InputStream returned null from FileUtil.getResourceAsStream()!");
//            }
            props.load(in);
            organizationName = props.getProperty("va.ehx.organizationName");
            //System.out.println("organizationName: "+organizationName);
        } catch (FileNotFoundException e) {
            LOG.error("static initializer", e); 
        } catch (IOException e) {
            LOG.error("static initializer", e); 
        }
    }

    public static String getOrganizationName() {
        return organizationName;
    }
   
}
