<%--
    Document   : edit
    Created on : Mar 17, 2016, 6:25:38 AM
    Author     : Johann Sonnenberg
--%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<f:mainTemplate headerText="Partner Organizations - Edit">
    <script language="JavaScript">
        $(document).ready(function () {
            $('#isTrustedClinicalSource').on('change', function (event) {
                $('#trustedSourceWarning').toggle();
            });
        });
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div id="errorMessage" class="errors" style="display: none;"></div>
            <div class="alert alert-warning" style="display: none;" id="trustedSourceWarning" role="alert">
                NOTE: Clinical data submitted from this partner will be input into VistA without a clinician's review.
            </div>
            <form name="frmEditOrganization" id="frmEditOrganization" action="OrganizationHandler.do_sec?editComplete=true" method="post" class="form-horizontal" data-toggle="validator" role="form">
                <input type="hidden" name="orgId" id="orgId" value="<c:out value="${organization.orgId}"/>" />
                <div class="form-group">
                    <label for="orgName" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Organization Name is a required field." labelText="Organization Name" /></label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationNameField']}"/>" type="text" name="orgName" id="orgName" maxlength="255" value="<c:out value="${organization.orgName}"/>" class="form-control js-simple-tooltip" required />
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgDescription" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Organization Description is a required field." labelText="Organization Description" useNoWrap="false" /></label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <textarea data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationDescriptionField']}"/>" rows="3" name="orgDescription" id="orgDescription" maxlength="255" class="form-control js-simple-tooltip" required><c:out value="${organization.orgDescription}"/></textarea>
                    </div>
                </div>    
                <div class="form-group">
                    <label for="orgNumber" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Organization Number is a required field." labelText="Organization Number" /></label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationNumberField']}"/>" type="text" name="orgNumber" id="orgNumber" maxlength="255" value="<c:out value="${organization.orgNumber}"/>" class="form-control js-simple-tooltip" required />
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgContact" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Contact Name</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationContactNameField']}"/>" type="text" name="orgContact" id="orgContact" maxlength="255" value="<c:out value="${organization.orgContact}"/>" class="form-control js-simple-tooltip" />
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgPhone" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Contact Phone</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationContactPhoneField']}"/>" type="text" name="orgPhone" id="orgPhone" maxlength="255" value="<c:out value="${organization.oorgPhoneNumber}"/>" class="form-control js-simple-tooltip" />
                    </div>
                </div>
                <div class="col-xs-offset-2 col-sm-offset-2 col-md-offset-2 col-lg-offset-2">
                    <div class="margin-left-5 checkbox form-group pad-bottom-10">
                        <label for="isTrustedClinicalSource">
                            <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationIsTrustedClinicalSourceField']}"/>" type="checkbox" aria-label="Is Trusted Clinical Source" name="isTrustedClinicalSource" id="isTrustedClinicalSource" value="Y" <c:if test="${organization.isTrustedClinicalSource == 'Y'}">checked="checked" </c:if>class="orgOptions js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-org-option="trustedSource" />
                            Is Trusted Clinical Source
                        </label> 
                    </div>
                </div>
                <div class="col-xs-offset-2 col-sm-offset-2 col-md-offset-2 col-lg-offset-2">
                    <div class="margin-left-5 checkbox form-group pad-bottom-10">
                        <label for="isBatchAnnounceEnabled">
                            <input data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationIsBatchAnnounceEnabledField']}"/>" type="checkbox" aria-label="Is Batch Announce Enabled" name="isBatchAnnounceEnabled" id="isBatchAnnounceEnabled" value="Y" <c:if test="${organization.isBatchAnnounceEnabled == 'Y'}">checked="checked" </c:if>class="orgOptions js-simple-tooltip" data-simpletooltip-prefix-class="secondary" />
                            Is Batch Announce Enabled
                        </label> 
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgActive" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Active</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <p class="form-control-static">
                            <c:choose>
                                <c:when test="${organization.active == 'Y'}">Yes</c:when>
                                <c:otherwise>No</c:otherwise>
                            </c:choose>
                        </p>
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgConsumerOnly" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Consumer Only</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <p class="form-control-static">
                            <c:choose>
                                <c:when test="${organization.orgConsumerOnly == 'Y'}">Yes</c:when>
                                <c:otherwise>No</c:otherwise>
                            </c:choose>
                        </p>
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgOid" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Organization ID</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <p class="form-control-static">
                            <c:out value="${organization.orgOid}"/>
                        </p>
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgDomain" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Domain</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <p class="form-control-static">
                            <c:out value="${organization.orgDomain}"/>
                        </p>
                    </div>
                </div>
                <div class="form-group">
                    <label for="orgPrefix" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Prefix</label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <p class="form-control-static">
                            <c:out value="${organization.orgCommunityIdPrefix}"/>
                        </p>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                        <a href="OrganizationHandler.do_sec?list=true" class="btn btn-default">Cancel</a>
                        <input name="btnSave" id="btnSearch" title="Save" class="btn btn-primary" type="submit" value="Save" />
                    </div>
                </div>
            </form>
        </div>
    </div>
</f:mainTemplate>