<%--
    Document   : organizations list
    Created on : Mar 15, 2016, 12:04:04 PM
    Author     : Johann Sonnenberg
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<f:mainTemplate headerText="Partner Organizations">
    <script language="JavaScript">
        $(document).ready(function () {
            //initial data table setup and call for the first recordset
            VAP.common.setProcessingForDataTable('tblOrganizations', 'divReportPanel');

            VAP.common.reportTable = $('#tblOrganizations').DataTable({
                destroy: true,
                searching: false,
                processing: true,
                serverSide: true,
                order: [[6, 'asc']],
                ajax: "OrganizationHandler.do_sec?getAll=true",
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                columnDefs: [
                    {orderable: false, targets: [12]},
                    {className: "vap-break-word vap-col-min-130", targets: [9]},
                    {className: "text-center vertical-align-center", targets: [12]}
                ],
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25
            });

            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('tblOrganizations', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('tblOrganizations');
            });
            
            VAP.common.constructUrl = function(methodName){
                var url= 'OrganizationHandler.do_sec' +
                    '?' + methodName + '=true' +
                    '&sortOrder=' + $('#tblOrganizations').dataTable().fnSettings().aaSorting[0][1] +
                    '&sortBy=' + $('#tblOrganizations').dataTable().fnSettings().aaSorting[0][0];

                return url;
            };
        });
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <c:if test="${not empty orgMessage}">
                <div class="alert alert-success alert-dismissible pad-bottom-10 pad-top-10 pad-left-10" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <c:out value="${orgMessage}" />
                </div>
            </c:if>
        </div>
    </div>
    <div class="row">
        <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default" id="divReportPanel">
                <div class="panel-heading">
                    <div class="panel-title">
                        <div class="text-right">
                            <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        </div>
                    </div>
                </div>    
                <div class="panel-body" id="organizationListPanel">
                    <table id="tblOrganizations" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                        <thead>
                            <tr role="row">
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationActiveColumn']}" />" style="max-width: 55px;"><span id="partnerOrganizationActiveHeader" data-simpletooltip-target="tableheader">Active</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationPhoneColumn']}" />" style="min-width: 80px;"><span id="partnerOrganizationPhoneHeader" data-simpletooltip-target="tableheader">Phone</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationPrefixColumn']}" />"><span id="partnerOrganizationPrefixHeader" data-simpletooltip-target="tableheader">Prefix</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationConsumerOnlyColumn']}" />"style="min-width: 75px;"><span id="partnerOrganizationConsumerOnlyHeader" data-simpletooltip-target="tableheader">Consumer Only</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationContactColumn']}" />"><span id="partnerOrganizationContactHeader" data-simpletooltip-target="tableheader">Contact</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationDomainColumn']}" />"><span id="partnerOrganizationDomainHeader" data-simpletooltip-target="tableheader">Domain</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationNameColumn']}" />"><span id="partnerOrganizationNameHeader" data-simpletooltip-target="tableheader">Name</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationDescriptionColumn']}" />"><span id="partnerOrganizationDescriptionHeader" data-simpletooltip-target="tableheader">Description</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationNumberColumn']}" />"><span id="partnerOrganizationNumberHeader" data-simpletooltip-target="tableheader">Number</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationIdColumn']}" />"><span id="partnerOrganizationIdHeader" data-simpletooltip-target="tableheader">Organization ID</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationTrustedClinicalSourceColumn']}" />" style="max-width: 95px;"><span id="partnerOrganizationTrustedClinicalSourceHeader" data-simpletooltip-target="tableheader">Trusted Clinical Source</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationIsBatchAnnounceEnabledColumn']}" />" style="max-width: 95px;"><span id="partnerOrganizationIsBatchAnnounceEnabledHeader" data-simpletooltip-target="tableheader">Batch Announce Enabled</span></th>
                                <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['partnerOrganizationActionColumn']}" />" style="max-width: 55px;"><span id="partnerOrganizationActionHeader" data-simpletooltip-target="tableheader">Action</span></th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>                              
</f:mainTemplate>