<%--
        Document   : Show the consent directive history
        Author     : Asha Amritraj
--%>
<%@page import="java.util.Date"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>

<table id="tblConsentHistory" class="table table-striped">
    <thead>
        <tr role="row">
            <th role="columnheader" class="text-center">Type of Consent Directive</th>
            <th role="columnheader" class="text-center">Purpose</th>
            <th role="columnheader" class="text-center">Authorization/<br />Revocation</th>
            <th role="columnheader" class="text-center">Entry Date</th>
            <th role="columnheader" class="text-center">Signature Date</th>
            <th role="columnheader" class="text-center">Expiration Date</th>
            <th role="columnheader" class="text-center">Inactivation Date</th>
            <th role="columnheader" class="text-center" style="width: 110px;">Mail Date(s)</th>
            <th role="columnheader" class="text-center" style="width: 110px;">Letters</th>
            <th role="columnheader" class="text-center">Status</th>
            <th role="columnheader" class="text-center">Entered By</th>
            <th role="columnheader" class="text-center">Comments</th>
            <th role="columnheader" class="text-center">
                <c:choose>
                    <c:when test="${isFormUploadAllowed}">Upload/</c:when>
                </c:choose> View Consent Form 
                <c:choose>
                    <c:when test="${isFormUploadAllowed}">
                        <br />
                        <i><span style="font-weight: normal;">(Max file size: <c:out value="${maxFileUploadSize/1000000}" /> megabytes)</span> </i>
                    </c:when>
                </c:choose>
            </th>
        </tr>
    </thead>
    <tbody>
        <c:forEach var="r" items="${consents}" varStatus="i">
            <c:choose>
                <%-- Check if this is a delayed authorization --%>
                <c:when test="${not empty r.delayedConsent}">
                    <tr role="row">
                        <td role="gridcell">
                            Delayed <c:out value="${r.consentDisplayName}" />
                        </td>
                        <td role="gridcell">
                            <c:choose>
                                <c:when test="${r.delayedConsent.consentTypeId.name eq 'SSA Authorization'}">
                                    COVERAGE
                                </c:when>
                                <c:otherwise>
                                    TREATMENT
                                </c:otherwise>
                            </c:choose>
                        </td>
                        <td role="gridcell">
                            <c:choose>
                                <c:when test="${r.delayedConsent.consentTypeId.name eq 'SSA Authorization'}">
                                    Authorized access to Social Security Administration
                                </c:when>
                                <c:when
                                    test="${r.delayedConsent.consentTypeId.name eq 'NwHIN Organization Restriction Authorization'}">
                                    Restricted select Providers and Organizations
                                </c:when>
                                <c:when test="${r.delayedConsent.consentTypeId.name eq 'NwHIN Authorization'}">
                                    Authorized access to Providers and Organizations
                                </c:when>
                            </c:choose>
                        </td>
                        <td role="gridcell"><fmt:formatDate pattern="MM/dd/yyyy" value="${r.delayedConsent.dateAdded}" /></td>
                        <td role="gridcell"></td>
                        <td role="gridcell"></td>
                        <td role="gridcell">
                            <c:if test="${r.delayedConsent.status eq 'CANCELED'}">
                                <fmt:formatDate pattern="MM/dd/yyyy" value="${r.delayedConsent.resolutionDate}" />
                            </c:if>
                        </td>
                        <td role="gridcell">
                            <!-- mail date(s) -->
                            <div>
                                <a href="#tblConsentHistory" class="vap-old-modal" data-title="Edit Mail Notification Dates" data-toggle="modal" data-target="#mailDateModal" data-mail-date-div="divMailDates<c:out value="${i.index}" />" data-delayed-consent-id="<c:out value="${r.delayedConsent.delayedConsentId}" />" data-consent-type="delayed" title="Edit Mail Notification Dates" aria-label="Edit Mail Notification Dates">
                                    Edit Mail Dates
                                </a>
                            </div>
                            <div id="divMailDates<c:out value="${i.index}" />">
                                <c:set var="dateCount" value="1" />
                                <c:forEach var="m" items="${r.mailNotifications}" varStatus="sd">
                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${m.sentDate}" /><br />
                                </c:forEach>
                            </div>
                        </td>
                        <td role="gridcell">&nbsp;
                            <%-- placeholder for letters, not used here --%>
                        </td>
                        <td role="gridcell"><c:out value="${r.delayedConsent.status}" />
                            <c:if test="${r.delayedConsent.status eq 'PENDING'}">
                                -
                                <c:forEach var="v" items="${r.delayedConsent.delayReasonCollection}" varStatus="loop">
                                    <c:out value="${v.name}" /> 
                                    <c:if test="${fn:length(r.delayedConsent.delayReasonCollection) gt 1 and (loop.index lt fn:length(r.delayedConsent.delayReasonCollection) - 1)}">, </c:if>
                                </c:forEach>
                            </c:if>
                        </td>
                        <td role="gridcell">
                            <c:out value="${r.delayedConsent.userId}" />
                        </td>
                        <td role="gridcell">
                            <div id="divConsentComments<c:out value="${i.index}" />">
                                <c:forEach var="c" items="${r.comments}">
                                    <c:if test="${c.delayedConsentId == r.delayedConsent.delayedConsentId}">
                                        <p style="white-space: pre-wrap;"><fmt:formatDate pattern="MM/dd/yyyy hh:mm:ss aa" value="${c.dateAdded}"/> CT <b><c:out value="${c.userId}" /></b>: <c:out value="${c.comments}" /></p>
                                    </c:if>
                                </c:forEach>
                            </div>
                            <p>
                                <a href="#tblConsentHistory" data-consent-type="<c:out value="${r.delayedConsent.consentTypeId.name}" />" data-delayed-consent-id="<c:out value="${r.delayedConsent.delayedConsentId}" />" data-consent-comment-div="divConsentComments<c:out value="${i.index}" />" data-toggle="modal" data-target="#consentCommentModal">Add Comment</a>
                            </p>
                        </td>
                        <td role="gridcell"></td>
                    </tr>
                </c:when>

                    <%-- Process normal consents --%>
                    <c:otherwise>
                        <c:choose>
                            <%-- Check if this was an opt-out --%>
                            <c:when test="${r.isRevoked}">
                            <tr role="row">
                                <td role="gridcell">
                                    <c:out value="${r.consentDisplayName}" />
                                </td>
                                <td role="gridcell">
                                    <c:out value="${r.normalConsent.purposeOfUse}" />
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.normalConsent.optoutConsentType.value eq 'SSA Revocation'}">
                                            Revoked access to Social Security Administration
                                        </c:when>
                                        <c:when test="${r.normalConsent.optoutConsentType.value eq 'NwHIN Organization Restriction Revocation'}">
                                            Revoked restriction to select Providers and Organizations
                                        </c:when>
                                        <c:when test="${r.normalConsent.optoutConsentType.value eq 'NwHIN Revocation'}">
                                            Revoked authorization to all Providers and Organizations
                                        </c:when>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${r.normalConsent.optoutTS}" />
                                </td>
                                <td role="gridcell">
                                     <fmt:formatDate pattern="MM/dd/yyyy" value="${r.normalConsent.optoutDate}" />
                                </td>
                                <td role="gridcell">&nbsp;</td>
                                <td role="gridcell">&nbsp;</td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.normalConsent.optoutConsentType.value eq 'NwHIN Revocation'}">
                                            <!-- mail date(s) -->
                                            <div>
                                                <a href="#tblConsentHistory" class="vap-old-modal" data-title="Edit Mail Notification Dates" data-toggle="modal" data-target="#mailDateModal" data-mail-date-div="divMailDates<c:out value="${i.index}" />" data-consent-dir-id="<c:out value="${r.normalConsent.consentDirId}" />" data-consent-type="eHeathExchangeRevocation" title="Edit Mail Notification Dates" aria-label="Edit Mail Notification Dates">
                                                   Edit Mail Dates
                                                </a>
                                            </div>
                                            <div id="divMailDates<c:out value="${i.index}" />">
                                                <c:forEach var="m" items="${r.mailNotifications}" varStatus="sd">
                                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${m.sentDate}" /><br />
                                                </c:forEach>
                                            </div>
                                            <%--<div>
                                                <a href="#" data-toggle="modal" data-target="#printLetterModal" data-consent-id="<c:out value="${r.normalConsent.consentDirId}" />" title="Generate Notification Letter" aria-label="Generate Notification Letter">
                                                    Generate Letters
                                                </a>
                                            </div>--%>
                                        </c:when>
                                        <c:otherwise>
                                            &nbsp;
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.normalConsent.optoutConsentType.value eq 'NwHIN Revocation'}">
                                            <!-- generate letter link -->
                                            <a href="#" data-toggle="modal" data-target="#printLetterModal" data-consent-id="<c:out value="${r.normalConsent.consentDirId}" />" title="Generate Notification Letter" aria-label="Generate Notification Letter">
                                                Generate Letters
                                            </a>
                                        </c:when>
                                        <c:otherwise>
                                            &nbsp;
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                                <td role="gridcell">&nbsp;</td>
                                <td role="gridcell">
                                    <c:out value="${r.user}" />
                                </td>
                                <td role="gridcell">
                                    <div id="divConsentComments<c:out value="${i.index}" />">
                                        <c:forEach var="c" items="${r.comments}">
                                            <c:if test="${c.consentType eq r.normalConsent.optoutConsentType.value}">
                                                <p style="white-space: pre-wrap;"><fmt:formatDate pattern="MM/dd/yyyy hh:mm:ss aa" value="${c.dateAdded}"/> CT <b><c:out value="${c.userId}" /></b>: <c:out value="${c.comments}" /></p>
                                            </c:if>
                                        </c:forEach>
                                    </div>
                                    <p>
                                        <a href="#tblConsentHistory" data-consent-type="<c:out value="${r.normalConsent.optoutConsentType.value}" />" data-consent-dir-id="<c:out value="${r.normalConsent.consentDirId}" />" data-consent-comment-div="divConsentComments<c:out value="${i.index}" />" data-toggle="modal" data-target="#consentCommentModal">Add Comment</a>
                                    </p>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.normalConsent.optoutReason.value eq 'Revoked'}">
                                            <c:choose>
                                                <c:when test="${r.optOutDocumentAttachment}">
                                                    <c:url var="url" value="PatientDetails.do_sec">
                                                        <c:param name="history" value="true" />
                                                        <c:param name="documentType" value="Revoke" />
                                                        <c:param name="consentDirId" value="${r.normalConsent.consentDirId}" />
                                                    </c:url>
                                                    <a href="<c:out value="${url}" />" class="btn btn-primary btn-xs">View/Print</a>
                                                </c:when>
                                                <c:otherwise>
                                                    <c:choose>
                                                        <c:when test="${isFormUploadAllowed}">
                                                            <form name="upload" action="PatientDetails.do_sec" method="POST" enctype="multipart/form-data">
                                                                <input type="hidden" name="consentDirId" value="<c:out value="${r.normalConsent.consentDirId}"/>" /> 
                                                                <input type="hidden" name="documentType" value="Revoke" /> 
                                                                <div class="form-group pad-bottom-10">
                                                                    <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                                                        <div class="input-group" id="divFileUpload">
                                                                            <label class="input-group-btn">
                                                                                <span class="btn btn-info btn-sm">
                                                                                    Browse&hellip; <input type="file" id="uploaded" name="uploaded" style="display: none;" accept="application/pdf" />
                                                                                </span>
                                                                            </label>
                                                                            <input type="text" id="fileNameHolder" class="form-control input-sm width-90" readonly />
                                                                        </div>
                                                                    </div>
                                                                </div>     
                                                                <div class="form-group">
                                                                    <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                                                        <input class="btn btn-primary btn-xs" type="SUBMIT" value="Upload" name="upload" title="Upload Authorization form" />
                                                                    </div>
                                                                </div>
                                                            </form>
                                                        </c:when>
                                                    </c:choose>
                                                </c:otherwise>
                                            </c:choose>
                                        </c:when>
                                    </c:choose>
                                </td>
                            </tr>
                        </c:when>  
                            
                        <%-- Otherwise this was an opt-in --%>
                        <c:otherwise>
                            <tr role="row">
                                <td role="gridcell">
                                    <c:out value="${r.consentDisplayName}" />
                                </td>
                                <td role="gridcell">
                                    <c:out value="${r.normalConsent.purposeOfUse}" />
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.normalConsent.optinConsentType.value eq 'SSA Authorization'}">
                                            Authorized access to Social Security Administration
                                        </c:when>
                                        <c:when test="${r.normalConsent.optinConsentType.value eq 'NwHIN Organization Restriction Authorization'}">
                                            Restricted select Providers and Organizations
                                        </c:when>
                                        <c:when test="${r.normalConsent.optinConsentType.value eq 'NwHIN Authorization'}">
                                            Authorized access to Providers and Organizations
                                        </c:when>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${r.optInEntryDate}" />
                                </td>
                                <td role="gridcell">
                                     <fmt:formatDate pattern="MM/dd/yyyy" value="${r.normalConsent.optinDate}" />
                                </td>
                                <td role="gridcell">
                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${r.normalConsent.expirationDate}" />
                                </td>
                                <td role="gridcell">
                                    <c:if test="${!empty r.normalConsent.optoutTS}">
                                        <fmt:formatDate pattern="MM/dd/yyyy" value="${r.normalConsent.optoutTS}" />
                                    </c:if>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${empty r.normalConsent.optoutTS and r.normalConsent.optinConsentType.value != 'NwHIN Organization Restriction Authorization'}">
                                            <!-- mail date(s) -->
                                            <div>
                                                <a href="#tblConsentHistory" class="vap-old-modal" data-title="Edit Mail Notification Dates" data-toggle="modal" data-target="#mailDateModal" data-mail-date-div="divMailDates<c:out value="${i.index}" />" data-consent-dir-id="<c:out value="${r.normalConsent.consentDirId}" />" data-consent-type="<c:out value="${r.normalConsent.optinConsentType}" />" title="Edit Mail Notification Dates" aria-label="Edit Mail Notification Dates">
                                                    Edit Mail Dates
                                                </a>
                                            </div>
                                            <div id="divMailDates<c:out value="${i.index}" />">
                                                <c:forEach var="m" items="${r.mailNotifications}" varStatus="sd">
                                                    <fmt:formatDate pattern="MM/dd/yyyy" value="${m.sentDate}" /><br />
                                                </c:forEach>
                                            </div>
                                            <%--<div>
                                                <a href="#" data-toggle="modal" data-target="#printLetterModal" data-consent-id="<c:out value="${r.normalConsent.consentDirId}" />" title="Generate Notification Letter" aria-label="Generate Notification Letter">
                                                    Generate Letters
                                                </a>
                                            </div>--%>
                                        </c:when>
                                        <c:otherwise>
                                            &nbsp;
                                        </c:otherwise>
                                    </c:choose>    
                                </td>
                                <td role="gridcell">
                                    <%-- generate letters --%>
                                     <c:choose>
                                        <c:when test="${empty r.normalConsent.optoutTS and r.normalConsent.optinConsentType.value != 'NwHIN Organization Restriction Authorization'}">
                                            <a href="#" data-toggle="modal" data-target="#printLetterModal" data-consent-id="<c:out value="${r.normalConsent.consentDirId}" />" title="Generate Notification Letter" aria-label="Generate Notification Letter">
                                                Generate Letters
                                            </a>
                                        </c:when>
                                        <c:otherwise>
                                            &nbsp;
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${!empty r.normalConsent.optoutTS}">
                                            INACTIVE - <c:out value="${r.normalConsent.optoutReason.value}" />
                                        </c:when>
                                        <c:otherwise>
                                            <c:choose>
                                                <c:when test="${r.normalConsent.optinConsentType.value eq 'NwHIN Organization Restriction Authorization'}">
                                                    <c:choose>									
                                                        <c:when test="${empty r.normalConsent.optoutTS}">
                                                            ACTIVE
                                                        </c:when>
                                                        <c:otherwise>
                                                            INACTIVE
                                                        </c:otherwise>
                                                    </c:choose>
                                                </c:when>
                                                <c:otherwise>
                                                    <fmt:formatDate pattern="yyyyMMdd" value="${r.normalConsent.expirationDate}" var="expireDate" />
                                                    <jsp:useBean id="dateValue" class="java.util.Date"/>
                                                    <fmt:formatDate pattern="yyyyMMdd" value="${dateValue}" var="todayDate" />
                                                    <c:choose>
                                                        <c:when test="${expireDate lt todayDate}">
                                                            INACTIVE - Authorization Expired
                                                        </c:when>
                                                        <c:otherwise>
                                                            ACTIVE
                                                        </c:otherwise>
                                                    </c:choose>
                                                </c:otherwise>
                                            </c:choose>
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                                <td role="gridcell">
                                    <c:out value="${r.user}" />
                                </td>
                                <td role="gridcell">
                                    <div id="divConsentComments<c:out value="${i.index}" />">
                                        <c:forEach var="c" items="${r.comments}">
                                            <c:if test="${c.consentType eq r.normalConsent.optinConsentType.value || (c.consentType eq 'NwHIN Revocation' && fn:length(r.normalConsent.optoutConsentType.value) == 0) || (c.consentType eq 'SSA Revocation' && fn:length(r.normalConsent.optoutConsentType.value) == 0)}"><%-- added the second check because on a revoke because of new auth, the comment is tied to the new auth but set as NwHIN Revoation in the CONSENT_COMMENT table --%>
                                                <p style="white-space: pre-wrap;"><fmt:formatDate pattern="MM/dd/yyyy hh:mm:ss aa" value="${c.dateAdded}"/> CT <b><c:out value="${c.userId}" /></b>: <c:out value="${c.comments}" /></p>
                                            </c:if>
                                        </c:forEach>
                                    </div>
                                    <p>
                                        <a href="#tblConsentHistory" data-consent-type="<c:out value="${r.normalConsent.optinConsentType.value}" />" data-consent-dir-id="<c:out value="${r.normalConsent.consentDirId}" />" data-consent-comment-div="divConsentComments<c:out value="${i.index}" />" data-toggle="modal" data-target="#consentCommentModal">Add Comment</a>
                                    </p>
                                </td>
                                <td role="gridcell">
                                    <c:choose>
                                        <c:when test="${r.optInDocumentAttachment}">
                                            <c:url var="url" value="PatientDetails.do_sec">
                                                <c:param name="history" value="true" />
                                                <c:param name="documentType" value="Authorize" />
                                                <c:param name="consentDirId" value="${r.normalConsent.consentDirId}" />
                                            </c:url>
                                            <a href="<c:out value="${url}" />" class="btn btn-primary btn-xs">View/Print</a>
                                        </c:when>   
                                        <c:otherwise>
                                            <c:choose>
                                                <c:when test="${isFormUploadAllowed}">
                                                    <form name="upload" action="PatientDetails.do_sec" method="POST" enctype="multipart/form-data" class="form-horizontal">
                                                        <input type="hidden" name="consentDirId" value="<c:out value="${r.normalConsent.consentDirId}" />" /> 
                                                        <input type="hidden" name="documentType" value="Authorize" /> 
                                                        <div class="form-group pad-bottom-10">
                                                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                                                <div class="input-group" id="divFileUpload">
                                                                    <label class="input-group-btn">
                                                                        <span class="btn btn-info btn-sm">
                                                                            Browse&hellip; <input type="file" id="uploaded" name="uploaded" style="display: none;" accept="application/pdf" />
                                                                        </span>
                                                                    </label>
                                                                    <input type="text" id="fileNameHolder" class="form-control input-sm width-90" readonly />
                                                                </div>
                                                            </div>
                                                        </div>     
                                                        <div class="form-group">
                                                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                                                <input class="btn btn-primary btn-xs" type="SUBMIT" value="Upload" name="upload" title="Upload Authorization form" />
                                                            </div>
                                                        </div>
                                                    </form>
                                                </c:when>
                                            </c:choose>
                                        </c:otherwise>
                                    </c:choose>
                                </td>
                            </tr>
                        </c:otherwise>
                    </c:choose>
                </c:otherwise>   
            </c:choose>
	</c:forEach>
        <c:if test="${empty consents}">
            <tr role="row">
                <td role="gridcell" colspan="12" class="text-center">No consents found for this patient.</td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
                <td role="gridcell"></td>
            </tr>
        </c:if>
    </tbody>
</table>