<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<%
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
%>

<f:mainTemplate headerText="Dashboard">
    <script type="text/javascript">
        $(document).ready(function () {
            
            //Widgets are loaded in succession even if the previous fails, the chain continues.
            
            //Expiring Consent Widget, Loads first #########################################################################################
            $.getJSON('ExpiringConsentsWidget.do_sec', function(data){
                $('#expiringNwHINConsents').html("<b>eHealth Exchange Authorizations:</b> " + data.expiringNwHINConsents);
                $('#expiringSSAConsents').html("<b>SSA Authorizations:</b> " + data.expiringSSAConsents);
                
                $('#expiringConsentLoading').hide();
                readyMonthlyConsentWidget(true);    
            }).fail(function(){
                readyMonthlyConsentWidget(true);    
            });
            
            //Monthly Consents Widget ######################################################################################################
            $('#previousMonth').click(function(){
               $('#monthValue').val(parseInt($('#monthValue').val()) - 1);
               $('#monthlyAuthorizationsLoading').show();
               readyMonthlyConsentWidget(false); 
            });
            
            $('#nextMonth').click(function(){
               $('#monthValue').val(parseInt($('#monthValue').val()) + 1);
               $('#monthlyAuthorizationsLoading').show();
               readyMonthlyConsentWidget(false); 
            });
            
            //Boolean parameter to determine if chaining is required, If widget spinner changes month chaining should not occur
            //Chaining should occur for initial page load.
            function readyMonthlyConsentWidget(chain){
                $.getJSON('MonthlyConsentsWidget.do_sec'+'?monthAdjustmentValue=' + $('#monthValue').val(), function (data) {
                    $('#addedeBenefits').html("<b>eHealth Exchange via eBenefits:</b> " + data.eBenefitsAddedAuths);
                    $('#addedManually').html("<b>eHealth Exchange Manual Entries:</b> " + data.manuallyAddedAuths);
                    $('#addedReAuth').html("<b>eHealth Exchange Re-Authorizations:</b> " + data.addedReAuths);
                    $('#ssaAuthAutomated').html("<b>SSA Automated:</b> " + data.ssaAuthAutomated);
                    $('#currentMonth').text(data.month);
                    $('#currentYear').text(data.year);
                    
                    //disable next button if at current month
                    if(parseInt($('#monthValue').val()) >= 0){
                        $('#nextMonth').prop('disabled', true);
                    } else {
                        $('#nextMonth').prop('disabled', false);
                    }
                    
                    $('#monthlyAuthorizationButtons').show();
                    if(chain){
                        readyLoginActivityWidget();
                    }
                    $('#monthlyAuthorizationsLoading').css("margin-top", "-30px"); //move the spinner up to overlay the month and buttons
                }).fail(function(){
                    if(chain){
                        readyLoginActivityWidget();
                    }
                }).complete(function(){
                    $('#monthlyAuthorizationsLoading').hide();
                });
            }
            
            //Log in Activity Widget #######################################################################################################
            function readyLoginActivityWidget(){
                $.getJSON('LoginActivityWidget.do_sec', function(data){
                    var lineGraph = document.getElementById("loginChart");
                    var myChart = new Chart(lineGraph, {

                        type: 'line',
                        data: {
                            labels: data.labels,
                            datasets: [
                                {
                                    label: 'Past 24 Hours',
                                    data: data.data,
                                    fill: false,
                                    borderColor: 'rgba(255, 69, 0, 1)' // 'rgba(75,192,192,1)'
                                }
                            ]
                        },
                        options: {
                            legend: {
                                onClick: function(e, legendItem) {
                                    //do nothing (don't hide or show a dataset when clicking on the legend
                                }
                            },
                            responsive: false,
                            maintainAspectRatio: false,
                            scales:{
                                yAxes: [{
                                    ticks: {
                                        maxTicksLimit: 5,
                                        beginAtZero: true
                                    }
                                }],
                                xAxes: [{
                                    ticks: {
                                        maxRotation: 70,
                                        minRotation: 70
                                    }
                                }]
                            }
                        }
                    });
                    $('#loginActivityLoading').hide();
                    $('#loginTableLink').show();
                    $('#loginTable').show();
                    $('#loginCanvas').find($("iframe")).attr('aria-hidden', 'true');
                    
                    $('#user-logins-tbody').append(data.tableHtml);
                    
                    $('#loginTableItself').find("tr").attr("role", "row");
                    
                    readyTransactionHistoryWidget();   
                }).fail(function(){
                    readyTransactionHistoryWidget();
                });
            }
            
            //Transaction History Widget ###################################################################################################
            function readyTransactionHistoryWidget(){
                $.getJSON('TransactionHistoryWidget.do_sec', function(data){
                    var lineGraph = document.getElementById("transactionChart");
                    var myChart = new Chart(lineGraph, {

                        type: 'line',
                        data: {
                            labels: data.labels,
                            datasets: [
                                {
                                    label: 'Policy Checks',
                                    data: data.exchange,
                                    fill: false,
                                    borderColor: 'rgba(71, 115, 170, 1)' //'rgba(255,90,132,1)'
                                },
                                {
                                    label: 'eBenefits Transactions',
                                    data: data.ebenefits,
                                    fill: false,
                                    borderColor: 'rgba(255, 69, 0, 1)' // 'rgba(75,192,192,1)'
                                }
                            ]
                        },
                        options: {
                            legend: {
                                onClick: function(e, legendItem) {
                                    //do nothing (don't hide or show a dataset when clicking on the legend
                                }
                            },
                            responsive: false,
                            maintainAspectRatio: false,
                            scales:{
                                yAxes: [{
                                    ticks: {
                                        maxTicksLimit: 5,
                                        beginAtZero: true
                                    }
                                }],
                                xAxes: [{
                                    ticks: {
                                        maxRotation: 70,
                                        minRotation: 70
                                    }
                                }]
                            }
                        }
                    });
                    
                    $('#transactions-tbody').append(data.tableHtml);
                    $('#transactionTableItself').find("tr").attr("role", "row");
                    $('#transactionTable').show();
                }).success(function(){
                    VAP.common.addAriaToJSCharts();
                    $('#transactionCanvas').find($("iframe")).attr('aria-hidden', 'true');
                });
                
                $('#transactionLoading').hide();
                $('#transactionTableLink').show();
            }
            
            $('.loginViewChange').on('click', function(e){
                $('#loginCanvas').toggle();
                $('#loginTable').toggle();
            });
            
            $('.transactionViewChange').on('click', function(e){
                $('#transactionCanvas').toggle();
                $('#transactionTable').toggle();
            });
        });
    </script>
    
    <div id="widgetsContainer" class="pad-top-10">        
        <div class="margin-bottom-20">
            <div class="alert alert-info">
                The authorization information displayed below is for 
                <c:choose>
                    <c:when test="${defaultUserFacility == null}">
                        all facilities.
                    </c:when>
                    <c:otherwise>
                        <c:out value="${defaultUserFacilityName}" />.
                    </c:otherwise>
                </c:choose>
                Times are in CST.
            </div>
            <div id="ExpiringConsentWidget" class="panel panel-default widget-inline margin-right-20" style="height: 200px;">
                <div class="panel-heading">
                    <div class="panel-title">
                        Expiring Authorizations (within 30 days)
                    </div>
                </div>
                <div class="panel-body">
                    <p id="expiringNwHINConsents"></p>
                    <p id="expiringSSAConsents"></p>
                    <div id="expiringConsentLoading" >
                        <p class="img-center"><img src="resources/images/ajax-loader_1.gif" alt="Loading Spin Wheel"/></p>
                    </div>
                </div>
            </div>
            <div id="MonthlyAuthorizationsWidget" class="panel panel-default widget-inline" style="height: 200px;">
                <div class="panel-heading">
                    <div class="panel-title">
                        New Consent Authorizations (by month)
                    </div>
                </div>
                <div class="panel-body">
                    <div class="text-center" id="monthlyAuthorizationButtons" style="display:none">
                        <button id="previousMonth" class="btn btn-default">Prev</button>
                        <b><span id="currentMonth"></span> <span id="currentYear"></span></b>
                        <button id="nextMonth" class="btn btn-default">Next</button>
                        <input type="hidden" id="monthValue" value="0"/>
                    </div>
                    <div id="monthlyAuthorizationsLoading" style="float: left; width: 100%;">
                        <div class="img-center">
                            <img src="resources/images/ajax-loader_1.gif" alt="Loading Spin Wheel"/>
                        </div>
                    </div>
                    <div style="position: absolute;">
                        <p id="addedeBenefits" class="pad-top-10"></p>
                        <p id="addedManually"></p>
                        <p id="addedReAuth"></p>
                    </div>
                    <div style="margin-top: 10px; position: absolute; text-align: right; width: 508px;">
                        <p id="ssaAuthAutomated"></p>
                    </div>
                </div>
            </div>
        </div>
        <div class="margin-bottom-5">
            <div id="loginActivityWidget" class="panel panel-default widget-inline margin-right-20">
                <div class="panel-heading">
                    <div class="panel-title">
                        VAP Application User Logins (within 24 hours)
                    </div>
                </div>
                <div class="panel-body">
                    <div id="loginActivityLoading">
                        <p class="img-center"><img src="resources/images/ajax-loader_1.gif" alt="Loading Spin Wheel"/></p>
                    </div>
                    <div id="loginCanvas" style="display: none;">
                        <div id="loginTableLink" class="pull-right" style="display:none;">
                            <a href="#loginActivityWidget" class="loginViewChange vap-bold-link" title="Click to view the VAP Application User Logins in a tabular format">View Table</a>
                        </div>
                        <canvas id="loginChart" width="500" height="300" data-title="VAP Application User Logins (within 24 hours) graph"></canvas>
                    </div>    
                    <div id="loginTable" style="display: none;">
                        <div class="pull-right">
                            <a href="#loginActivityWidget" class="loginViewChange vap-bold-link" title="Click to view the VAP Application User Logins in a chart format">View Chart</a>
                        </div>
                        <table id="loginTableItself" class="table table-striped" role="grid">
                            <caption>This table shows VAP application user login counts from the past 24 hours</caption>
                            <thead>
                                <tr role="row">
                                    <th role="columnheader">Time</th>
                                    <th role="columnheader">User Login Count</th>
                                </tr>
                            </thead>
                            <tbody id="user-logins-tbody">

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div id="TransactionHistoryWidget" class="panel panel-default widget-inline">
                <div class="panel-heading">
                    <div class="panel-title">
                        VAP Application Web Calls (within 24 hours)
                    </div>
                </div>
                <div class="panel-body">
                    <div id="transactionLoading">
                        <p class="img-center"><img src="resources/images/ajax-loader_1.gif" alt="Loading Spin Wheel"/></p>
                    </div>
                    <div id="transactionCanvas" style="display: none;">
                        <div id="transactionTableLink" class="pull-right" style="display: none;">
                            <a href="#TransactionHistoryWidget" class="transactionViewChange vap-bold-link" title="Click to view the VAP Application Web Calls in a tabular format">View Table</a>
                        </div>
                        <canvas id="transactionChart" width="500" height="300" data-title="VAP Application Web Calls (within 24 hours) graph"></canvas>
                    </div>
                    <div id="transactionTable" style="display: none;">
                        <div class="pull-right">
                            <a href="#TransactionHistoryWidget" class="transactionViewChange vap-bold-link" title="Click to view the VAP Application Web Calls in a chart format">View Chart</a>
                        </div>
                        <table id="transactionTableItself" class="table table-striped" role="grid">
                            <caption>This table shows VAP application web services call counts from the past 24 hours</caption>
                            <thead>
                                <tr role="row">
                                    <th role="columnheader">Time</th>
                                    <th role="columnheader">eBenefits Transactions</th>
                                    <th role="columnheader">Policy Checks</th>
                                </tr>
                            </thead>
                            <tbody id="transactions-tbody">

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>