<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<%
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    
    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Data Quality Export Search">
    <script type="text/javascript" src="js/OptionTransfer.js"></script>
    <script type="text/javascript">
        var opt = new OptionTransfer("list1", "list2");
        opt.setAutoSort(false);
        opt.setDelimiter(",");
        opt.saveNewLeftOptions("newLeft");
        opt.saveNewRightOptions("newRight");    
        
    $(document).ready(function () {        
        $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });

            //make sure the end date calendar is closed when the start date one opens and vice versa
            $('#startDate').on('ab.datepicker.opening', function(){
                $('#endDate').datepicker('hide');
            });

            $('#endDate').on('ab.datepicker.opening', function(){
                $('#startDate').datepicker('hide');
            });

        $('#btnGenerate').on('click', function(event)
        {
            validateList2();
            // hide and clear the error message
            $('#validationMsg').hide();
            $('#validationMsg').html(''); //clear the error message

            <%--
               No dynamic changes to what's required now.
               updateRequiredFields();
            --%>

            var errFound = false;
            var startDate = $('#startDate').val();
            var endDate = $('#endDate').val();

            var dateErrMsg = VAP.common.validateStartAndEndDate(startDate, endDate);
            if (dateErrMsg !== '')
            {
                $('#validationMsg').html(dateErrMsg);
                errFound = true;
            }

            if ($('#list2')[0].children.length === 0) {
                $('#validationMsg').append('You must select one or more partners/organizations');
                errFound = true;
            }
            // validate the form
            var validationRslt = $('#dqExportSearchForm').validator('validate');
            if (validationRslt.has('.has-error').length)
            {
                $('#validationMsg').prepend('One or more fields on the search form are invalid. ');
                errFound = true;
            }
            
            if(errFound) {
                $('#validationMsg').show();
            } else {
                $('#dqExportSearchForm').submit();
            }
        });
        
        $('#startDate,#endDate').on('change', function () {
            // if either date changes, hide the error message if its not already hidden
            $('#validationMsg').hide();
        });        

        opt.init(document.dqExportSearchForm);
        
        $('#dqExportSearchForm').validator();
        
        $('#list1').keyup(function( event ) {
            if ( event.which == 13 ) {
              opt.transferRight();
              validateList2();
              event.preventDefault();
            } else if (event.which == 65 && event.ctrlKey==1) {
                event.preventDefault();
            }
        });
        $('#list1').keydown(function( event ) {
            if (event.which == 65 && event.ctrlKey==1) {
                $("#list1 option").prop("selected",true);
                event.preventDefault();
            }
        });
        $('#list2').keyup(function( event ) {
            if ( event.which == 13 ) {
              opt.transferLeft();
              validateList2();
              event.preventDefault();
            } else if (event.which == 65 && event.ctrlKey==1) {
                event.preventDefault();
            }
        });
        $('#list2').keydown(function( event ) {
            if (event.which == 65 && event.ctrlKey==1) {
                $("#list2 option").prop("selected",true);
                event.preventDefault();
            }
        });
        
        $('#list2').on('focusout', function() {
            validateList2();
        });
        
        $('.moveButtons').on('click', function () {
            validateList2();
        });

    });
    
    validateList2 = function() {
        if ($('#list2')[0].children.length === 0) {
            //we don't have anything selected, so we better show this is required
            $('#divList2').addClass('has-error has-danger');
            $('#divList2Select').addClass('has-error has-danger');
        } else {
            $('#divList2').removeClass('has-error has-danger');
            $('#divList2Select').removeClass('has-error has-danger');
            $('#formErrors').hide();
            $('#formErrors').html(''); // clear the form error from loading time
        }
    };
    </script>
    
    <c:if test="${not empty message}">
        <div class="alert alert-success alert-dismissible margin-bottom-15 pad-bottom-10 pad-top-10 pad-left-10">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <c:out value="${message}" />
        </div>
    </c:if>
    <cpp:errors />
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="patientSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="patientSearchPanel">
                    <div class="alert alert-info">
                    '*' Indicates required information. Enter the document generation date range you wish to include in the query.
                    </div>
                    <div id="validationMsg" class="alert alert-danger" style="display: none;" role="alert"></div>
                    <form class="form-horizontal" role="form" id="dqExportSearchForm" name="dqExportSearchForm" action="AdapterDateRangeReport.do_sec" method="GET" data-toggle="validator">

                        <input type="hidden" name="newLeft" value="" /> 
                        <input type="hidden" name="newRight" value="" /> 
        
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label"><f:requiredField altText="Start Date" labelText="Start Date" useNoWrap="false" /></label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" required /> --%>
                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                <input type="text" name="startDate" id="startDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['dqExportSearchStartDateField']}" />" value="<c:out value="${startDateDefault}" />" required />
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1  control-label"><f:requiredField altText="End Date" labelText="End Date" useNoWrap="false" /></label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" required /> --%>
                            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2">
                                <input type="text" name="endDate" id="endDate" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['dqExportSearchEndDateField']}" />" value="<c:out value="${endDateDefault}" />" required />
                            </div>
                        </div>
                    <div class="alert alert-info">
                        Selection of at least one provider or organization is required. To make a selection, use Ctrl A to select all, or use the up and down arrow keys on your keyboard
                        to navigate to the appropriate provider or organization, and Press Enter on your keyboard to select. If you are using a mouse or mouse pad, you may double-click to include an item for selection. 
                    </div>
                        <div class="form-group pad-bottom-20">
                            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                <div id="divList1">
                                    <label for="list1" class="control-label">List of Providers and Organizations</label>
                                    <div>
                                        <select class="listSelect form-control" name="list1" id="list1" multiple size="10" onDblClick="opt.transferRight(); validateList2();">
                                            <c:forEach var="r" items="${activeOrgs}" varStatus="loop1">
                                                <option  value="<c:out value="${loop1.index}" />"/><c:out value="${r.orgName}"/></option>
                                            </c:forEach>
                                            <c:forEach var="r" items="${inactiveOrgs}" varStatus="loop2">
                                                <option value="Z${loop2.index}" />[INACTIVE] <c:out value="${r.orgName}" /></option>
                                            </c:forEach>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                            <div class="alert alert-info">
Review selected providers and organizations in the list below. To remove a provider from the selected list, use the up and down navigation arrows on your keyboard
to navigate to the provider or organization you wish to remove and press Enter. To remove all selected providers and organizations, press Ctrl A and then press Enter.
If you are using a mouse or mouse pad, you may  double-click to remove a selected item. <strong>Note: at least one provider or organization is required to generate the query.</strong>
                            </div>
                            <div class="form-group pad-bottom-20">
                                <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                                    <div id="divList2">
                                        <label for="list2" class="control-label"><f:requiredField altText="Selected Providers and Organizations" labelText="Selected Providers and Organizations" useNoWrap="false" /></label>
                                        <div id="divList2Select">
                                            <select name="list2" class="listSelect form-control" multiple size="10" id="list2" onDblClick="opt.transferLeft(); validateList2();"></select>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="alert alert-info">
To restrict the query to a specific patient, enter the patient Social Security Number (SSN) and patient name.
Note: Patient information is optional. If you have selected/entered a Start Date, and End Date, and have selected at least one provider or organization, you may generate the query.
                            </div>
                        <div class="form-group">
                            <label for="ssn" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">SSN</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <input type="text" class="form-control" id="ssn" name="ssn" maxlength="9" data-tooltip="<c:out value="${descriptors['patientSearchSSNField']}" />" pattern="^\d{9}(,\d{9})*$" /> --%>
                                <input type="text" class="form-control js-simple-tooltip" id="ssn" name="ssn" maxlength="9" data-simpletooltip-text="<c:out value="${descriptors['patientSearchSSNField']}" />" pattern="^\d{9}(,\d{9})*$" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="lastName" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Last Name</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <input type="text" class="form-control" id="lastName" name="lastName" maxlength="255" data-tooltip="<c:out value="${descriptors['patientSearchLastNameField']}" />" /> --%>
                                <input type="text" class="form-control js-simple-tooltip" id="lastName" name="lastName" maxlength="255" data-simpletooltip-text="<c:out value="${descriptors['patientSearchLastNameField']}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="firstName" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">First Name</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <input type="text" class="form-control" id="firstName" name="firstName" maxlength="255" data-tooltip="<c:out value="${descriptors['patientSearchFirstNameField']}" />" /> --%>
                                <input type="text" class="form-control js-simple-tooltip" id="firstName" name="firstName" maxlength="255" data-simpletooltip-text="<c:out value="${descriptors['patientSearchFirstNameField']}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-4 text-right">
                                <button id="btnGenerate" class="btn btn-primary" type="button">Generate</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>