<%--
    Document   : general error page
    Created on : 07/01/2016
    Author     : Johann Sonnenberg
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<f:mainTemplate headerText=""><%-- An Error Occurred --%>
    <script language="JavaScript">
        $(document).ready(function () {
            $('#copiedAlert').hide();

            $('#copyButton').on('click', function () {
                clipboard.copy($('#stackTrace').val());
                $('#copiedAlert').show();
                $('#copiedAlert').delay(500).fadeIn('normal', function () {
                    $(this).delay(2500).fadeOut();

                });
            });
        });
    </script>

    <div class="row pad-left-15 pad-right-15 pad-bottom-15 vap-flex-row">
        <div class="col-xs-1 col-sm-1 col-md-1 col-lg-1 vap-well-error well-sm vertical-center text-center vap-flex-column white vap-size-46">
            <i class="fa fa-exclamation-circle" aria-hidden="true"></i>
        </div>
        <div class="col-xs-11 col-sm-11 col-md-11 col-lg-11 vap-well-error-text well-sm vap-flex-column">
            <p class="vap-size-14">We are sorry, but an error has occurred while processing your request. <strong><c:out value="${customMessage}"/></strong></p> 
            <p>Please retry your request again. If you continue to get this message, call the <c:out value="${helpdeskName}"/> (<c:out value="${helpdeskNumber}"/>).</p>
            <p>The following steps can be taken to resolve this:</p>
            <ol>
                <li>Hit the Back button and try your request again.</li>
                <li>If you are searching, try to search using different parameters.</li>
                <li>If you are searching, try to search with no parameters.</li>
            </ol>
            <c:if test="${not empty fullStackTrace}">
                <br />
                <p class="vap-size-14">Developer Debugging Information</p>
                <div class="form-group">
                    <div class="text-right margin-bottom-10">
                        <span id="copiedAlert" class="bg-success pad-5">Copied!</span>
                        <button id="copyButton" class="btn btn-danger">Copy to Clipboard</button>
                    </div>
                    <div>
                        <textarea rows="10" id="stackTrace" class="form-control" aria-label="stackTrace_info"><c:out value="${fullStackTrace}"/></textarea>
                    </div>
                    
                    <div aria-live="polite" role="status" id="stackTrace_info" class="hidden">Shows stack trace information</div>
                </div>
            </c:if>
        </div>
    </div>
    <%-- <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="alert alert-danger">
                <p>We are sorry, but an error has occurred while processing your request. <strong><c:out value="${customMessage}"/></strong></p> 
                <p>Please retry your request again. If you continue to get this message, call the <c:out value="${helpdeskName}"/> (<c:out value="${helpdeskNumber}"/>).</p>
                <p>The following steps can be taken to resolve this:</p>
                <ol>
                    <li>Hit the Back button and try your request again.</li>
                    <li>If you are searching, try to search using different parameters.</li>
                    <li>If you are searching, try to search with no parameters.</li>
                </ol>
            </div>
        </div>
    </div>
    <c:if test="${not empty fullStackTrace}">
        <div class="row">
            <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
                <div class="form-group">
                    <div>
                        <textarea rows="10" id="stackTrace" class="form-control" aria-label="stackTrace_info"><c:out value="${fullStackTrace}"/></textarea>
                    </div>
                    <div class="text-right margin-top-10">
                        <span id="copiedAlert" class="bg-success pad-10">Copied!</span>
                        <button id="copyButton" class="btn btn-primary">Copy to Clipboard</button>
                    </div>
                    <div aria-live="polite" role="status" id="stackTrace_info" class="hidden">Shows stack trace information</div>
                </div>
            </div>
        </div>
    </c:if> --%>
</f:mainTemplate>