<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<f:mainTemplate headerText="">
    <div class="row">
        <div class="col-md-4 col-sm-4"></div>
        <div class="col-md-4 col-sm-4">
            <c:if test="${not empty message}"> <%-- used for any messaging back from the server. i.e. error logging in or logged out --%> 
                <div class="alert alert-success alert-dismissible pad-bottom-10 pad-top-10 pad-left-10">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <c:out value="${message}" />
                </div>
            </c:if>
            <cpp:errors />
            <div class="row">
                <div class="well">
                    <h4>Log In</h4>
                    <hr />
                    <form class="form-horizontal" name="loginForm" id="loginForm" action="Login.do" method="POST" role="form" data-toggle="validator">
                        <div class="form-group">
                            <label for="username" class="col-lg-4 col-md-4 col-sm-4 col-xs-4 control-label"><f:requiredField altText="Username is a required field." labelText="Username" /></label>
                            <div class="col-lg-8 col-md-8 col-sm-8 col-xs-8">
                                <input type="text" class="form-control" id="username" name="username" required />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="password" class="col-lg-4 col-md-4 col-sm-4 col-xs-4 control-label"><f:requiredField altText="Password is a required field." labelText="Password" /></label>
                            <div class="col-lg-8 col-md-8 col-sm-8 col-xs-8">
                                <input type="password" class="form-control" id="password" name="password" required />
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-sm-12 col-md-12 col-xs-12 text-right">
                                <input name="login" type="submit" value="Log in" title="Log in" class="btn btn-primary" />
                            </div>
                        </div>
                    </form>
                    <div class="text-right pad-bottom-10">
                        <small>
                            <a href="#" data-toggle="modal" data-target="#termsOfUseModal">Know the VAP Terms of Use</a>
                        </small>
                    </div>
                    <div class="text-right">
                        <small>Need Help? VA Helpdesk Support: 1-888-596-4357</small>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-4 col-sm-4"></div>
    </div>
    
    <div class="modal fade" id="termsOfUseModal" role="dialog" data-backdrop="static" aria-labelledby="termsOfUseModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1" id="termsOfUseModalContent">
                    <div class="modal-header">
                        <h4 class="modal-title" id="termsOfUseModalLabel">Terms of Use</h4>
                    </div>
                    <div class="modal-body">
                        <p class="text-center"><strong>**WARNING* *WARNING* *WARNING* *WARNING* *WARNING* *WARNING**</strong></p>
                        <p class="text-justify">This system is intended to be used by [authorized VA network users] for viewing and retrieving information only except as otherwise explicitly authorized. VA information resides on and transmits through computer systems and networks funded by VA; all use is considered to be understanding and acceptance that there is no reasonable expectation of privacy for any data or transmissions on Government Intranet or Extranet (non-public) networks or systems. All transactions that occur on this system and all data transmitted through this system are subject to review and action including (but not limited to) monitoring, recording, retrieving, copying, auditing, inspecting, investigating, restricting access, blocking, tracking, disclosing to authorized personnel, or any other authorized actions by all authorized VA and law enforcement personnel. All use of this system constitutes understanding and unconditional acceptance of these terms.</p>
                        <p class="text-justify">Unauthorized attempts or acts to either (1) access, upload, change, or delete information on this system, (2) modify this system, (3) deny access to this system, or (4) accrue resources for unauthorized use on this system are strictly prohibited. Such attempts or acts are subject to action that may result in criminal, civil, or administrative penalties.</p>
                        <p class="text-center"><strong>**WARNING* *WARNING* *WARNING* *WARNING* *WARNING* *WARNING**</strong></p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="acceptTermsOfUse" class="btn btn-primary" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>