<%--
    Document   : facilitiesFilterAjax
    Created on : May 18, 2016
    Author     : Irakli Kakushadze
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<style>
    .fd-a {}

    .fd-checkbox-facility{}

    .fd-checkbox-station{}

    .fd-label {
        font-weight: normal;
        padding-left: 5px;
        margin-bottom: 0px !important;
    }

    .fd-div-checkbox {
        white-space: nowrap;
    }

    .fd-div-checkbox-indented {
        margin-left: 25px;
        white-space: nowrap;
    }

    .fd-label-visn {
        font-size: large;
        font-weight: bold;
    }
    .fd-listitem-facility {}

    .fd-listitem-station {}
</style>

<div class="row">
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <div class="pull-left">
            <strong>Show VISNs:</strong>
        </div>
        <div class="pull-right">
            <a class="fd-a btn btn-default" href="#" data-container="fd-visnList" data-select="true">Select all</a>
            <a class="fd-a btn btn-default" href="#" data-container="fd-visnList" data-select="">Unselect all</a>
        </div>
        <div class="clearfix"></div>
    </div>
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <div class="pull-left">
            <strong>Show facilities:</strong>
        </div>
        <div class="pull-right">
            <a class="fd-a btn btn-default" href="#" data-container="fd-facilityList" data-select="true">Select all</a>
            <a class="fd-a btn btn-default" href="#" data-container="fd-facilityList" data-select="">Unselect all</a>
        </div>
        <div class="clearfix"></div>
    </div>
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <div class="pull-left">
            <strong>Your selection:</strong>
        </div>
        <div class="pull-right">
            <a class="fd-a btn btn-default" href="#" data-container="fd-stationList" data-select="true">Select all</a>
            <a class="fd-a btn btn-default" href="#" data-container="fd-stationList" data-select="">Unselect all</a>
        </div>
        <div class="clearfix"></div>
    </div>
</div>
<div class="row pad-top-10">
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <div id="fd-visnList" class="fd-list panel panel-default">
            <div class="panel-body panel-body-400">
                <c:forEach var="visn" items="${visns}">
                    <div class="fd-div-checkbox">
                        <input type="checkbox" id="v<c:out value="${visn.id}"/>" checked="checked"/>
                        <label class="fd-label" for="v<c:out value="${visn.id}"/>"><c:out value="${visn.visnName}"/></label>
                    </div>
                </c:forEach>
            </div>
        </div>
    </div>
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <c:set var="visnId" value=""/>
        <c:set var="groupedOrder" value="0"/>
        <div class="fd-list">
            <div class="fd-list panel panel-default">
                <div id="fd-facilityList" class="panel-body panel-body-400"></div>
            </div>
        </div>
    </div>
    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
        <c:set var="visnId" value=""/>
        <c:set var="groupedOrder" value="0"/>
        <div class="fd-list">
            <div class="fd-list panel panel-default">
                <div id="fd-stationList" class="panel-body panel-body-400"></div>
            </div>
        </div>
    </div>
</div>

<script>

    $(document).ready(function () {
        setTimeout(function() {
            var facilities = [];
            var stations = [];
            <c:set var="bad" value="'" />
            <c:set var="good" value="//'" />
            <c:forEach var="facility" items="${facilities}">facilities.push({facilityStation:'<c:out value="${facility.facilityStation}"/>', facilityName:'<c:out value="${fn:replace(facility.facilityName, bad, good)}"/>', visnId:'<c:out value="${facility.visnId}"/>'});
            </c:forEach>
            <c:forEach var="station" items="${stations}">stations.push({facilityStation:'<c:out value="${station.facilityStation}"/>', parent:'<c:out value="${station.parent}"/>', facilityName:'<c:out value="${fn:replace(station.facilityName, bad, good)}"/>', visnId:'<c:out value="${station.visnId}"/>'});
            </c:forEach>

            html = '';
            var visnId = '';
            var groupedOrder = 0;

            for (var i = 0; i < facilities.length; i++) {
                var facility = facilities[i];
                if (facility.visnId !== visnId) {
                    visnId = facility.visnId;
                    groupedOrder++;
                    html += '<div class="fd-listitem-visn text-center" data-groupedOrder="' + (10000 + groupedOrder) + '" data-visnId="' + visnId + '">';
                    html += '<label class="fd-label-visn">';
                    html += (visnId === '' ? 'Unknown VISN' : 'VISN ' + visnId);
                    html += '</label>';
                    html += '</div>';
                }

                groupedOrder++;
                html += '<div class="fd-div-checkbox fd-listitem-facility" data-groupedOrder="' + (10000 + groupedOrder) + '" data-text="' + facility.facilityName + '">';
                html += '<input checked="checked" class="fd-checkbox-facility" data-facilityName="' + facility.facilityName + '"';
                html += ' data-visnId="' + facility.visnId + '" id="f' + facility.facilityStation + '" type="checkbox"/>';
                html += '<label class="fd-label" for="f' + facility.facilityStation + '">' + facility.facilityName + ' (' + facility.facilityStation + ')</label>';
                html += '</div>';
            }

            $('#fd-facilityList').html(html);

            html = '';
            visnId = '';
            groupedOrder = 0;
            for (var i = 0; i < facilities.length; i++) {
                var facility = facilities[i];
                if (facility.visnId !== visnId) {
                    visnId = facility.visnId;
                    groupedOrder++;
                    html += '<div class="fd-listitem-visn text-center" data-groupedOrder="' + (10000 + groupedOrder) + '" data-visnId="' + visnId + '">';
                    html += '<label class="fd-label-visn">';
                    html += (visnId === '' ? 'Unknown VISN' : 'VISN ' + visnId);
                    html += '</label>';
                    html += '</div>';
                }

                groupedOrder++;
                html += '<div class="fd-div-checkbox fd-listitem-station" data-groupedOrder="' + (10000 + groupedOrder) + '" data-text="' + facility.facilityName + '">';
                html += '<input checked="checked" class="fd-checkbox-facility" data-facilityName="' + facility.facilityName + '" data-facilityStation="' + facility.facilityStation + '"';
                html += ' data-stationNumber="' + facility.facilityStation + '" data-visnId="' + facility.visnId + '" id="s' + facility.facilityStation + '" type="checkbox"/>';
                html += '<label class="fd-label" for="s' + facility.facilityStation + '">' + facility.facilityName + ' (' + facility.facilityStation + ')</label>';
                
                for (var j = 0; j < stations.length; j++) {
                    var station = stations[j];
                    if (station.parent === facility.facilityStation) {
                        html += '<div class="fd-div-checkbox-indented">';
                        html += '<input checked="checked" class="fd-checkbox-station" data-facilityName="' + station.facilityName + '" data-facilityStation="' + facility.facilityStation + '"';
                        html += ' data-stationNumber="' + station.facilityStation + '" data-visnId="' + station.visnId + '" id="s' + station.facilityStation + '" type="checkbox"/>';
                        html += '<label class="fd-label" for="s' + station.facilityStation + '">' + station.facilityName + ' (' + station.facilityStation + ')</label>';
                        html += '</div>';
                    }
                }
                html += '</div>';
            }

            $('#fd-stationList').html(html);

            if ($('#fd-selectedFacilities').children(':first').val() !== 'ALL') {
                <%-- Either the default facility is selected, or there's a previous selection --%>
                var selectedStations = $('input[name="stationNumbers"]').val().toString();
                
                <%-- Uncheck everything --%>
                $('#fd-visnList input[type=checkbox]').each(function() {
                    $(this).prop('checked', false);
                });
                $('#fd-facilityList input[type=checkbox]').each(function() {
                    $(this).prop('checked', false);
                });                
                $('#fd-stationList input[type=checkbox]').each(function() {
                    $(this).prop('checked', false);
                });
                
                selectedStations = selectedStations.split(',');
                for (var i = 0; i < selectedStations.length; i++) {
                    var selectedStation = selectedStations[i];
                    var facilityStation;
                    
                    var checkbox = $('#s' + selectedStation);
                    checkbox.prop('checked', true);
                    
                    if (checkbox.prop('className') === 'fd-checkbox-station') {
                        <%-- Check the parent checkbox --%>
                        var parentCheckbox = checkbox.parent().parent().children(':first');
                        parentCheckbox.prop('checked', true);
                        facilityStation = parentCheckbox.prop('id').substr(1);
                    } else {
                        facilityStation = selectedStation;
                    }
                    
                    <%-- Check the corresponding checkbox in 'Show facilities' (2nd list) --%>
                    var facilityCheckbox = $('#f' + facilityStation);
                    facilityCheckbox.prop('checked', true);
                    
                    <%-- Check the corresponding VISN checkbox (1st list) --%>
                    var visnCheckbox = $('#v' + facilityCheckbox.attr('data-visnId'));
                    visnCheckbox.prop('checked', true);
                }
            }
            
            facilitiesDialog.updateCheckboxes(true);
            
            facilitiesDialog.handleAggregation();
            
            $('#fd-facilitiesDialog').dialog('open');
        }, 400);
    });
    
    $('.fd-a').on('click', function() {
        var containerId = $(this).attr('data-container');
        var checked = $(this).attr('data-select');
        $('#' + containerId + ' input[type=checkbox]').each(function() {
            $(this).prop('checked', checked);
        });
        facilitiesDialog.updateCheckboxes(false);
    });

    $('#fd-facilitiesContainer').on('click', 'input', function() {
        var aggregate = $('#fd-checkbox-aggregateAtFacilityLevel').is(':checked');
        if (aggregate) {
            $('#fd-stationList .fd-checkbox-facility').each(function() {
                var checked = $(this).is(':checked');
                $('.fd-checkbox-station', $(this).parent()).each(function () {
                    $(this).prop('checked', checked);
                });
            });
        }
        
        facilitiesDialog.updateCheckboxes(false);
    });

    facilitiesDialog.updateCheckboxes = function (loading) {
        <%-- Update facility checkboxes --%>
        $('#fd-facilityList input[type=checkbox]').each(function() {
            var vid = 'v' + $(this).attr('data-visnId');
            var visible = $('#' + vid).is(':checked');
            $(this).parent().toggle(visible);
        });

        <%-- Update facility VISN headers --%>
        $('#fd-facilityList .fd-listitem-visn').each(function() {
            if ($('#fd-groupByVisn').is(':checked')) {
                var vid = 'v' + $(this).attr('data-visnId');
                $('#' + vid).is(':checked') ? $(this).show() : $(this).hide();
            } else {
                $(this).hide();
            }
        });

        <%-- Update station checkboxes --%>
        visnHeadersToShow = [];
        $('#fd-stationList input[type=checkbox]').each(function() {
            var fid = 'f' + $(this).attr('data-facilityStation');
            var visible = ($('#' + fid).is(':visible') || loading) && $('#' + fid).is(':checked');
            $(this).next().css({'font-weight': $(this).is(':checked') ? 'bold' : 'normal'});
            $(this).parent().toggle(visible);
            if (visible) {
                var visnId = $(this).attr('data-visnId');
                visnHeadersToShow[visnId] = 'show';
            }
        });

        <%-- Update station VISN headers --%>
        $('#fd-stationList .fd-listitem-visn').each(function() {
            if ($('#fd-groupByVisn').is(':checked')) {
                var visnId = $(this).attr('data-visnId');
                visnHeadersToShow[visnId] === 'show' ? $(this).show() : $(this).hide();
            } else {
                $(this).hide();
            }
        });
    };

</script>