<%--
    Document   : apiUsage
    Created on : Feb 4, 2016, 9:05:42 AM
    Author     : Johann Sonnenberg
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);

    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Service Audit Report">
    <script language="JavaScript">
        $(document).ready(function () {
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });

            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });

            //make sure the end date calendar is closed when the start date one opens and vice versa
            $('#startDate').on('ab.datepicker.opening', function(){
                $('#endDate').datepicker('hide');
            });

            $('#endDate').on('ab.datepicker.opening', function(){
                $('#startDate').datepicker('hide');
            });

            $('#service').on('change', function () {
                var service = $('#service').val();

                if (service !== 'ALL') {

                    //make the ajax call to get the calls (methods) for the selected web service
                    $.ajax({url: "ServiceAuditReport.do_sec?getCallsByWebService=true&webservice=" + service, success: function (result) {
                            $('#method').html(result);
                        }});
                } else {
                    $('#method').html('<option value="ALL">All</option>');
                }
            });

            var service = $('#service').val();
            var method = $('#method').val();
            var authorized = $('#authorized').val();
            var success = $('#success').val();
            var duration = $('#duration').val();
            var startDate = $('#startDate').val();
            var endDate = $('#endDate').val();

            //initial data table setup and call for the first recordset
            VAP.common.setProcessingForDataTable('tblServiceAuditReport', 'divReportPanel');

            var auditReportTable = $('#tblServiceAuditReport').DataTable({
                deferLoading: 0,
                destroy: true,
                searching: false,
                processing: true,
                serverSide: true,
                order: [[2, 'desc']],
                ajax: "ServiceAuditReport.do_sec?doSearch=true&useJSON=true&webservice=" + service + "&method=" + method + "&authorized=" + authorized + "&success=" + success + "&duration=" + duration + "&startDate=" + startDate + "&endDate=" + endDate,
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25,
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                columnDefs: [
                    //{className: "dt-head-center", targets: [0,1,2,3,4,5,6]},
                    {className: "text-right", targets: [7]}
                ]
            });

            auditReportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('tblServiceAuditReport', auditReportTable);
                VAP.common.addSrollingToDataTable('tblServiceAuditReport');
            });

            //when the search button is pressed this function is used
            $('#btnSearch').on('click', function () {
                $('#tblServiceAuditReport .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var service = $('#service').val();
                var method = $('#method').val();
                var authorized = $('#authorized').val();
                var success = $('#success').val();
                var duration = $('#duration').val();
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();

                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);
                
                if (errorMessage !== '')
                {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    auditReportTable.ajax.url("ServiceAuditReport.do_sec?doSearch=true&useJSON=true&webservice=" + service + "&method=" + method + "&authorized=" + authorized + "&success=" + success + "&duration=" + duration + "&startDate=" + startDate + "&endDate=" + endDate).load();
                }
            });

            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#results').hide();
        });
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="serviceAuditReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="serviceAuditReportSearchPanel">
                    <form name="patientSearchForm" class="form-horizontal" role="form">
                        <div id="errorMessage" class="alert alert-danger" style="display: none;" role="alert"></div>
                        <div class="form-group">
                            <label for="service" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Service</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select id="service" name="service" class="form-control" data-tooltip="<c:out value="${descriptors['serviceAuditServiceField']}" />"> --%>
                                <select id="service" name="service" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditServiceField']}" />">
                                    <option value="ALL" selected="selected">All</option>
                                    <c:forEach var="ws" items="${webservices}" varStatus="i">
                                        <option id="<c:out value="${ws}" />"><c:out value="${ws}" /></option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="method" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Method</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select id="method" name="method" class="form-control" data-tooltip="<c:out value="${descriptors['serviceAuditMethodField']}" />"> --%>
                                <select id="method" name="method" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditMethodField']}" />">
                                    <option value="ALL">All</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="authorized" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Authorized</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select id="authorized" name="authorized" class="form-control" data-tooltip="<c:out value="${descriptors['serviceAuditAuthorizedField']}" />"> --%>
                                <select id="authorized" name="authorized" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditAuthorizedField']}" />">
                                    <option value="ALL">All</option>
                                    <option value="1">Yes</option>
                                    <option value="0">No</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="success" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Success</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select id="success" name="success" class="form-control" data-tooltip="<c:out value="${descriptors['serviceAuditSuccessField']}" />"> --%>
                                <select id="success" name="success" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditSuccessField']}" />">
                                    <option value="ALL">All</option>
                                    <option value="1">Yes</option>
                                    <option value="0">No</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="duration" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Duration</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <%-- <select id="duration" name="duration" class="form-control" data-tooltip="<c:out value="${descriptors['serviceAuditDurationField']}" />"> --%>
                                <select id="duration" name="duration" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditDurationField']}" />">
                                    <option value="ALL">All</option>
                                    <option value="10">&gt; 10ms</option>
                                    <option value="50">&gt; 50ms</option>
                                    <option value="100">&gt; 100ms</option>
                                    <option value="200">&gt; 200ms</option>
                                    <option value="500">&gt; 500ms</option>
                                </select>
                            </div>
                        </div>
                        <%-- <div id="datesTip" class="form-group" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />"> --%>
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">Start Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" placeholder="mm/dd/yyyy" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="startDate" id="startDate" class="form-control js-simple-tooltip" placeholder="mm/dd/yyyy" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label">End Date</label>
                            <%-- <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" placeholder="mm/dd/yyyy" /> --%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" name="endDate" id="endDate" class="form-control js-simple-tooltip" placeholder="mm/dd/yyyy" data-simpletooltip-text="<c:out value="${descriptors['startDateEndDateField']}" />"/>
                            </div>
                        </div>
                        <%-- </div> --%>
                        <div class="form-group">
                            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-4 text-right">
                                <input name="btnSearch" id="btnSearch" title="Search" class="btn btn-primary" type="button" value="Search" />
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <a href="#" title="Search Results" aria-label="Search Results" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="serviceAuditReportResultsPanel"></i></a> Search Results
                        </div>
                    </div>    
                    <div class="panel-body" id="serviceAuditReportResultsPanel">
                        <table id="tblServiceAuditReport" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditWebServiceHeader" data-tooltip="<c:out value="${descriptors['serviceAuditWebServiceColumn']}" />">Web Service</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditMethodHeader" data-tooltip="<c:out value="${descriptors['serviceAuditMethodColumn']}" />">Method</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditEventDateHeader" data-tooltip="<c:out value="${descriptors['serviceAuditEventDateColumn']}" />">Event Date (CT)</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditIPAddressHeader" data-tooltip="<c:out value="${descriptors['serviceAuditIPAddressColumn']}" />">IP Address</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditDomainHeader" data-tooltip="<c:out value="${descriptors['serviceAuditDomainColumn']}" />">Domain</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditAuthorizedHeader" data-tooltip="<c:out value="${descriptors['serviceAuditAuthorizedColumn']}" />">Authorized</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditSuccessHeader" data-tooltip="<c:out value="${descriptors['serviceAuditSuccessColumn']}" />">Success</span></th> --%>
                                    <%-- <th role="columnheader" class="text-center"><span id="serviceAuditDurationHeader" data-tooltip="<c:out value="${descriptors['serviceAuditDurationColumn']}" />" data-tooltip-position="left">Duration (ms)</span></th> --%>
                                    
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditWebServiceColumn']}" />"><span id="serviceAuditWebServiceHeader" data-simpletooltip-target="tableheader">Web Service</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditMethodColumn']}" />"><span id="serviceAuditMethodHeader" data-simpletooltip-target="tableheader">Method</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditEventDateColumn']}" />"><span id="serviceAuditEventDateHeader" data-simpletooltip-target="tableheader">Event Date (CT)</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditIPAddressColumn']}" />"><span id="serviceAuditIPAddressHeader" data-simpletooltip-target="tableheader">IP Address</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditDomainColumn']}" />"><span id="serviceAuditDomainHeader" data-simpletooltip-target="tableheader">Domain</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditAuthorizedColumn']}" />"><span id="serviceAuditAuthorizedHeader" data-simpletooltip-target="tableheader">Authorized</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditSuccessColumn']}" />"><span id="serviceAuditSuccessHeader" data-simpletooltip-target="tableheader">Success</span></th>
                                    <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['serviceAuditDurationColumn']}" />"><span id="serviceAuditDurationHeader" data-simpletooltip-target="tableheader">Duration (ms)</span></th>
                                </tr>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>
