<%@page import="gov.va.nvap.web.user.UserHelper"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<%
    String userName = UserHelper.getUserName(request);
    pageContext.setAttribute("userName", userName);
%>

<nav class="navbar navbar-inverse" style="border-radius:0px;">
    <div class="container-fluid">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="PatientSearch.do_sec"><img src="resources/images/vap_logo_final.png" border="0" alt="Veterans Authorizations and Preferences logo" /></a>
        </div>
        <div id="navbar" class="collapse navbar-collapse">
            <ul class="nav navbar-nav navbar-right">
                <c:if test="${!empty userName}">
                    <cpp:userInRole role="VAPApplicationWebUser">
                        <li><a href="PatientSearch.do_sec">Patient Search</a></li>
                    </cpp:userInRole>
                    <cpp:userInRole role="VAPApplicationReportsUser">
                        <li>
                            <a href="#" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Summary Reports <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="Dashboard.do_sec">Dashboard</a></li>
                                <li><a href="DisclosureSummaryReport.do_sec">Disclosures</a></li>
                                <li><a href="ReceivedNwHINDocumentSummaryReport.do_sec">Received <c:out value="${organizationName}" /> Documents</a></li>
                                <li><a href="DocumentSizeReport.do_sec">Document Size</a></li>
                                <li><a href="OptInOptOutSummaryReport.do_sec">Consent Directive</a></li>
                                <li><a href="OptInSummaryReport.do_sec">Opt-In Patients</a></li>
                                <li><a href="DelayedConsentSummaryReport.do_sec">Delayed Consent</a></li>
                                <li><a href="PatientDiscoverySummaryReport.do_sec">Patient Discovery Audit</a></li>
                            </ul>
                        </li>
                        <li>
                            <a href="#" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Detailed Reports <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="DocumentDisclosureReport.do_sec">Disclosures</a></li>
                                <li><a href="InboundDocumentReport.do_sec">Received <c:out value="${organizationName}" /> Documents</a></li>
                                <li><a href="OptInOptOutReport.do_sec">Consent Directive</a></li>
                                <li><a href="OptInReport.do_sec">Opt-In Patients</a></li>
                                <li><a href="ExpiringConsentReport.do_sec">Expiring Consent</a></li>
                                <li><a href="DelayedConsentReport.do_sec">Delayed Consent</a></li>
                                <li><a href="PatientDiscoveryReport.do_sec">Patient Discovery Audit</a></li>
                                <li><a href="ScheduledExports.do_sec">Scheduled Exports</a></li>
                                <li><a href="AdapterDateRangeReport.do_sec">Data Quality Export</a></li>   
                                <li><a href="DqTransmissionLogReport.do_sec">Data Quality Upload Transmission Log</a></li>
                            </ul>
                        </li>
                    </cpp:userInRole>
                    <cpp:userInRole role="VAPApplicationWebAdministrator">
                        <li>
                            <a href="#" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Admin <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="BatchAnnounce.do_sec">Batch Announce Patients</a></li>
                                <li><a href="BatchManagerQuery.do_sec">Manage Batches</a></li>
                                <li><a href="ServiceAuditReport.do_sec">Service Audit</a></li>
                                <li><a href="OrganizationHandler.do_sec">Partner Organizations</a></li>
                                <li><a href="MonthlyReceivedDocumentsReport.do_sec">Monthly Received Documents</a></li>
                                <li><a href="ViewFacility.do_sec">Facilities</a></li>
                                <%-- JPS - commenting this out for now until we get full requirements and can implement this functionality <li><a href="StatusChecker.do_sec">Connected Systems Status Check</a></li> --%>
                            </ul>
                        </li>
                    </cpp:userInRole>
                </c:if>
                <li class="dropdown">
                    <a href="#" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Resources <span class="caret"></span></a>
                    <ul class="dropdown-menu">
                        <li><a href="http://URL/" target="_blank">VA Intranet Home</a></li>
                        <li><a href="http://www.va.gov/about_va/" target="_blank">About VA</a></li>
                        <li><a href="http://URL/landing_organizations.htm" target="_blank">Organizations</a></li>
                        <li><a href="http://URL/directory/" target="_blank">Find a Facility</a></li>
                        <li><a href="http://URL/landing_employee.htm" target="_blank">Employee Resources</a></li>
                    </ul>
                </li>
                <c:if test="${!empty userName}">
                    <li class="dropdown">
                        <a href="#" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Welcome <strong><c:out value="${userName}" /></strong> <span class="caret"></span></a>
                        <ul class="dropdown-menu">
                            <li><a href="<c:out value="${userguideUrl}" />" target="_blank">User Guide</a></li>
                            <cpp:userInRole role="VAPApplicationWebAdministrator">
                                <li><a href="ManageScheduledExports.do_sec">Advanced Scheduling</a></li>
                            </cpp:userInRole>
                            <li><a href="ExpiringConsentNotification.do_sec">Expiring Consent Notification</a></li>
                            <li><a href="SetDefaultFacility.do_sec">Set Default Facility</a></li>
                            <li><a href="About.do_sec">About</a></li>
                            <li><a href="#" data-toggle="modal" data-target="#confirmLogoutModal">Logout</a></li>
                        </ul>
                    </li>
                </c:if>
            </ul>
        </div><!--/.nav-collapse -->
    </div>
</nav>